﻿angular.module('starter.controllers', [])

    .controller('homeControl', function ($scope, $rootScope, $http, $window, $state, $interval, $ionicSlideBoxDelegate, $ionicPopup, $ionicViewSwitcher, UserLocation, UserSecurity) {
        //监听设备就绪事件
        document.addEventListener('deviceready', function () {
            $rootScope._platform = device.platform;
            $rootScope._uuid = device.uuid;
            StatusBar.backgroundColorByHexString("#387ef5");
            StatusBar.styleLightContent();
            window.plugins.jPushPlugin.receiveMessageInAndroidCallback = function (data) {
                if (typeof (data.message) != "undefined" && typeof (data.extras) != "undefined" && typeof (data.extras['cn.jpush.android.MSG_ID']) != "undefined") {
                    var pushData = JSON.parse(data.message);
                    pushData.pushNo = data.extras['cn.jpush.android.MSG_ID'];
                    $rootScope._pushData.push(pushData);
                }
            }
            window.plugins.jPushPlugin.openNotificationInAndroidCallback = function (data) {
                if (typeof (data.extras) != "undefined" && typeof (data.extras['cn.jpush.android.MSG_ID']) != "undefined") {
                    for (var i = 0; i <= $rootScope._pushData.length - 1; i++) {
                        if ($rootScope._pushData[i].pushNo == data.extras['cn.jpush.android.MSG_ID']) {
                            var pushData = $rootScope._pushData[i];
                            $rootScope._pushData.splice(i, 1);
                            if (pushData.type == "State") {
                                if (typeof (pushData.parameter) != "undefined" && pushData.parameter != null && pushData.parameter != "") {
                                    var pushParam = JSON.parse(pushData.parameter);
                                    var stateParam = {};
                                    stateParam[pushParam.name] = pushParam.value;
                                    $state.go(pushData.value, stateParam);
                                }
                                else {
                                    $state.go(pushData.value);
                                }
                            }
                            if (pushData.type == "URL") {
                                cordova.InAppBrowser.open(pushData.value, '_blank', 'location=no');
                            }
                            break;
                        }
                    }
                }
            }
            window.plugins.jPushPlugin.receiveMessageIniOSCallback = function (data) {
                if (data.length > 14) {
                    var pushStr = data.substr(12, data.length - 14);
                    var pushData = JSON.parse(pushStr);
                    var confirmPopup = $ionicPopup.confirm({ title: '接收到推送消息', template: '<p style="text-indent:2em;">' + pushData.text + '</p>', cancelText: '详情', okText: '关闭' });
                    confirmPopup.then(function (res) {
                        if (!res) {
                            if (typeof (pushData.type) != "undefined" && typeof (pushData.value) != "undefined" && pushData.type.length > 1 && pushData.value.length > 1) {
                                if (pushData.type == "State") {
                                    if (typeof (pushData.parameter) != "undefined" && pushData.parameter != null && pushData.parameter != "") {
                                        var pushParam = JSON.parse(pushData.parameter);
                                        var stateParam = {};
                                        stateParam[pushParam.name] = pushParam.value;
                                        $state.go(pushData.value, stateParam);
                                    }
                                    else {
                                        $state.go(pushData.value);
                                    }
                                }
                                else {
                                    if (pushData.type == "URL") {
                                        cordova.InAppBrowser.open(pushData.value, '_blank', 'location=no');
                                    }
                                }
                            }
                        }
                    });
                }
            }

            $scope.currentLocation = "正在定位";
            //更新线
            $scope.checkAppUpdate(function () {
                $scope.checkUserDevice();
            })
            //定位线
            $scope.getPositionStart(function (lat, lon) {
                $scope.currentLocation = "正在解析地址...";
                //事件线
                $scope.addMemberEvent(function () {
                    $scope.getStoreList();
                })
                //地址解析线
                $scope.getLocationName(lat, lon, function (locationName) {
                    $scope.currentLocation = locationName;
                }, function (message) {
                    $scope.currentLocation = message;
                });
            }, function (message) {
                $scope.currentLocation = message;
            });
        }, false);
        $scope.$on('$ionicView.enter', function () {
            if (UserLocation.locationStatus == "Selected") {
                $scope.currentLocation = UserLocation.locationName;
                $scope.getStoreList();
            }
            if (typeof ($scope.photoPlayData) != "undefined" && $scope.photoPlayData.length > 0) {
                $ionicSlideBoxDelegate.$getByHandle('photoPlay').next();
            }
            $scope.keepMessageUpdate = true;
            $scope.updateMyMessageData();
        });
        $scope.$on('$ionicView.leave', function () {
            $scope.keepMessageUpdate = false;
        });
        //检查更新
        $scope.checkAppUpdate = function (successCallback) {
            //console.log("更新线-1 checkAppUpdate");
            cordova.getAppVersion.getVersionNumber().then(function (version) {
                $rootScope._appVersion = version;
                if (navigator.connection.type == Connection.WIFI) {
                    $http({ method: "POST", url: $rootScope._serverSvc + "getMemberAppVersion", data: { 'version': version } })
                       .success(function (sdata) {
                           var versionData = JSON.parse(sdata.d)
                           if (versionData.needUpdate == "Yes") {
                               if ($rootScope._platform === "Android") {//如果是安卓，提示下载文件
                                   var confirmPopup = $ionicPopup.confirm({ title: '版本升级', template: versionData.updateIntroduction, cancelText: '取消', okText: '升级' });
                                   confirmPopup.then(function (res) {
                                       if (res) {
                                           var url = versionData.androidUrl;
                                           var targetPath = cordova.file.externalCacheDirectory + "bthStore.apk";
                                           var options = {};
                                           var fileTransfer = new FileTransfer();
                                           window.plugins.toast.showLongBottom("开始下载新版本,请稍侯");
                                           fileTransfer.download(url, targetPath, function (entry) {
                                               cordova.plugins.fileOpener2.open(entry.toURL(), 'application/vnd.android.package-archive');
                                           }, function (error) {
                                               console.log(error);
                                           }, true, options);
                                       }
                                   });
                               }
                               else {
                                   if ($rootScope._platform === "IOS") {//如果是苹果，提示到应用商店下载
                                       var alertPopup = $ionicPopup.alert({
                                           title: '更新版本',
                                           template: '发现可用的更新，请到应用商店下载新版本'
                                       });
                                       alertPopup.then(function (res) { });
                                   }
                               }
                           }
                           if (typeof (successCallback) == "function") {
                               successCallback();
                           }
                       });
                }
            });
        }
        //检查推送ID
        $scope.checkUserDevice = function (successCallback, errorCallback) {
            //console.log("更新线-2 checkUserDevice");
            if ($rootScope._uuid.length >= 14 && $rootScope._uuid.length <= 48) {//判断UUID是否有效
                $http({ method: "POST", url: $rootScope._serverSvc + "checkMemberDeviceExist", data: { 'uuid': $rootScope._uuid } })
                    .success(function (sdata) {
                        var checkData = JSON.parse(sdata.d);
                        if (checkData.status != "Done") {
                            var getRegistrationID = function () {
                                window.plugins.jPushPlugin.getRegistrationID(function (data) {
                                    if (data.length == 0) {
                                        window.setTimeout(getRegistrationID, 1500);
                                    }
                                    else {
                                        $http({ method: "POST", url: $rootScope._serverSvc + "addMemberDevice", data: { 'uuid': $rootScope._uuid, 'pushID': data, 'serial': device.serial, 'platform': $rootScope._platform, 'manufacturer': device.manufacturer } })
                                        .success(function (sdata) {
                                            if (typeof (successCallback) == "function") {
                                                successCallback();
                                            }
                                        });
                                    }
                                });
                            }
                            try {
                                getRegistrationID();
                            }
                            catch (ex) {
                                if (typeof (errorCallback) == "function") {
                                    errorCallback(ex.message);
                                }
                            }
                        }
                        else {
                            if (typeof (successCallback) == "function") {
                                successCallback();
                            }
                        }
                    })
            }
        }
        //开始定位
        $scope.getPositionStart = function (successCallback, errorCallback) {
            //console.log("定位线 -1 getPositionStart");
            if ($rootScope._platform == "Android") {//安卓平台使用百度定位
                $scope.getBaiduLocation(successCallback, errorCallback);
            }
            else {//其他平台使用GEO定位
                $scope.getGeoLocation(successCallback, errorCallback);
            }
        }
        //Geo定位
        $scope.getGeoLocation = function (successCallback, errorCallback) {
            //console.log("定位线 -2 getGeoLocation");
            navigator.geolocation.getCurrentPosition(
                function (position) {
                    var lat, lon;
                    $http({ method: "GET", url: "http://api.map.baidu.com/geoconv/v1/?coords=" + position.coords.longitude + "," + position.coords.latitude + "&from=1&to=5&ak=UAZSHs5k0pv7lashP6ZnUcbb" })
                        .success(function (sdata) {
                            if (sdata.result.length > 0) {
                                var baiduLocation = sdata.result[0];
                                lon = baiduLocation.x;
                                lat = baiduLocation.y;
                                UserLocation.located = true;
                                UserLocation.locationX = lon;
                                UserLocation.locationY = lat;
                                UserLocation.realX = lon;
                                UserLocation.realY = lat;
                                UserLocation.locationStatus = "Done";
                                if (typeof (successCallback) == "function") {
                                    successCallback(lat, lon);
                                }
                            }
                            else {
                                if (typeof (errorCallback) == "function") {
                                    errorCallback("无法解析您的位置");
                                }
                            }
                        })
                        .error(function (sdata) {
                            UserLocation.located = true;
                            UserLocation.locationStatus = "Error";
                            if (typeof (errorCallback) == "function") {
                                errorCallback("坐标转换失败");
                            }
                        });
                },
                function (error) {
                    UserLocation.located = true;
                    UserLocation.locationStatus = "Error";
                    if (typeof (errorCallback) == "function") {
                        errorCallback("定位失败");
                    }
                }, { maximumAge: 3000, timeout: 20000, enableHighAccuracy: true });
        }
        //百度定位
        $scope.getBaiduLocation = function (successCallback, errorCallback) {
            //console.log("定位线 -2 getBaiduLocation");
            baidu_location.getCurrentPosition(
                function (position) {
                    if (typeof (position.time) != "undefined") {
                        UserLocation.located = true;
                        UserLocation.locationX = position.longitude;
                        UserLocation.locationY = position.latitude;
                        UserLocation.realX = position.longitude;;
                        UserLocation.realY = position.latitude;
                        UserLocation.locationStatus = "Done";
                        if (typeof (successCallback) == "function") {
                            successCallback(position.latitude, position.longitude);
                        }
                    }
                    else {
                        //被拦截，尝试GEO定位
                        $scope.getGeoLocation(successCallback, errorCallback);
                    }
                },
                function (error) {
                    UserLocation.located = true;
                    UserLocation.locationStatus = "Error";
                    if (typeof (errorCallback) == "function") {
                        errorCallback("定位失败");
                    }
                });
        }
        //获取位置名称,使用百度地址解析
        $scope.getLocationName = function (lat, lon, successCallback, errorCallback) {
            //console.log("定位线 -3 getLocationName");
            $http({ method: "GET", url: "http://api.map.baidu.com/geocoder/v2/?ak=UAZSHs5k0pv7lashP6ZnUcbb&callback=&location=" + lat + "," + lon + "&output=json&pois=0" })
                .success(function (sdata) {
                    var locationName = sdata.result.formatted_address;
                    var province = sdata.result.addressComponent.province;
                    var city = sdata.result.addressComponent.city;
                    locationName = locationName.substr((province + city).length);
                    UserLocation.locationName = locationName;
                    if (typeof (successCallback) == "function") {
                        successCallback(locationName);
                    }
                })
                .error(function (sdata) {
                    if (typeof (errorCallback) == "function") {
                        errorCallback("地址解析失败");
                    }
                });
        }
        //发送初始化事件
        $scope.addMemberEvent = function (successCallback) {
            //console.log("定位线 -4 addMemberEvent");
            if (UserSecurity.checked) {
                $http({ method: "POST", url: $rootScope._serverSvc + "addMemberEvent", data: { 'mid': UserSecurity.mid, 'token': UserSecurity.token, 'type': '1', 'locationX': UserLocation.realX, 'locationY': UserLocation.realY, 'uuid': $rootScope._uuid, 'remark': $rootScope._appVersion } })
                    .success(function (sdata) {
                        if (typeof (successCallback) == "function") {
                            successCallback();
                        }
                    });
            }
            else {
                if (typeof (successCallback) == "function") {
                    successCallback();
                }
            }
        }
        //初始化店铺列表
        $scope.getStoreList = function (successCallback, errorCallback) {
            //console.log("定位线 -5 getStoreList");
            if (UserLocation.located && (UserLocation.locationStatus == "Done" || UserLocation.locationStatus == "Selected")) {
                $http({ method: "POST", url: $rootScope._serverSvc + "getStoreList", data: { 'startNumber': 0, 'locationX': UserLocation.locationX, 'locationY': UserLocation.locationY, 'serviceType': '0', 'service': '0', 'range': '0', 'order': '0', 'keyword': '' } })
                    .success(function (sdata) {
                        $scope.StoreList = JSON.parse(sdata.d);
                        if ($scope.StoreList.length > 0) {
                            $scope.lastStoreGeted = false;
                        }
                        else {
                            $scope.lastStoreGeted = true;
                        }
                        if (typeof (successCallback) == "function") {
                            successCallback();
                        }
                    });
            }
            else {
                if (typeof (errorCallback) == "function") {
                    errorCallback();
                }
            }
        }

        //以上在deviceReady中使用

        //初始化全局变量，读取本地数据
        $scope.initAppData = function () {
            //console.log("初始线 -1");
            //初始化全局变量
            $rootScope._serverUrl = "http://123.56.9.63:8088/";
            $rootScope._serverSvc = "http://123.56.9.63:8088/AppService.svc/";
            $rootScope._fileUploadProcessor = "http://123.56.9.63:8088/FileReciver.ashx"
            $rootScope._alipayTradeNotifyUrl = "http://123.56.9.63:8088/TradeNotifyAP.ashx";
            $rootScope._alipayChargeNotifyUrl = "http://123.56.9.63:8088/ChargeNotifyAP.ashx";
            $rootScope._platform = "";
            $rootScope._appVersion = "";
            $rootScope._uuid = "";
            $rootScope._dealParam = "0";
            $rootScope._pushData = [];
            $rootScope._memberInfo = { 'balanceNum': null, 'scoreNum': null, 'keyNum': null };
            $rootScope._myMessageData = { 'hasUnread': false, 'messageID': null, 'createTime': null };
            //读取本地数据
            var userLocalData = JSON.parse($window.localStorage['linkerUser'] || "{}");
            UserSecurity.mid = userLocalData.mid || '';
            UserSecurity.token = userLocalData.token || '';
            UserSecurity.cellNumber = userLocalData.cellNumber || '';
            //初始化局部变量
            $scope.currentLocation = "正在定位...";
            $scope.valid = { 'refreshPosition': true };
            $scope.lastStoreGeted = true;
            $scope.keepMessageUpdate = true;
        }
        //判断登录状态
        $scope.checkUserStatus = function (callback) {
            //console.log("初始线 -2 checkUserStatus");
            if (UserSecurity.mid == '' || UserSecurity.token == '') {
                UserSecurity.checked = false;
                if (typeof (callback) == "function") {
                    callback();
                }
            }
            else {
                $http({ method: "POST", url: $rootScope._serverSvc + "checkMemberLoginValid", data: { "mid": UserSecurity.mid, "token": UserSecurity.token } })
                    .success(function (sdata) {
                        var logStatus = JSON.parse(sdata.d);
                        if (logStatus.status == "Done") {
                            UserSecurity.checked = true;
                        }
                        else {
                            UserSecurity.checked = false;
                        }
                        if (typeof (callback) == "function") {
                            callback();
                        }
                    });
            }
        }
        //读取服务类型信息
        $scope.getServiceType = function (callback) {
            //console.log("初始线 -3 getServiceType");
            $http({ method: "POST", url: $rootScope._serverSvc + "getServiceType", data: {} })
                .success(function (sdata) {
                    $scope.serviceData = JSON.parse(sdata.d);
                    $scope.getShowImage(callback);
                });
        }
        //读取图片轮播和广告图片数据
        $scope.getShowImage = function (callback) {
            //console.log("初始线 -4 getShowImage");
            $http({ method: "POST", url: $rootScope._serverSvc + "getPhotoPlay", data: {} })
            .success(function (sdata) {
                $scope.photoPlayData = JSON.parse(sdata.d);
                $ionicSlideBoxDelegate.$getByHandle('photoPlay').update();
                $ionicSlideBoxDelegate.$getByHandle('photoPlay').loop(true);
                $http({ method: "POST", url: $rootScope._serverSvc + "getHomeBanner", data: {} })
                    .success(function (sdata) {
                        $scope.homeBannerData = JSON.parse(sdata.d);
                        if (typeof (callback) == "function") {
                            callback();
                        }
                    });
            });
        }
        //图片轮播更换图片事件
        $scope.photoPlayChanged = function (index) {
        }
        //点击图片轮播图片
        $scope.photoPlayClick = function (index) {
            cordova.InAppBrowser.open($scope.photoPlayData[index].targetUrl, '_blank', 'location=no');
        }
        //获取更多店铺信息
        $scope.getStoreListMore = function () {
            if (!$scope.lastStoreGeted && $scope.StoreList.length > 0) {
                $http({ method: "POST", url: $rootScope._serverSvc + "getStoreList", data: { 'startNumber': $scope.StoreList.length, 'locationX': UserLocation.locationX, 'locationY': UserLocation.locationY, 'serviceType': '0', 'service': '0', 'range': '0', 'order': '0', 'keyword': '' } })
                .success(function (sdata) {
                    var storeData = JSON.parse(sdata.d);
                    if (storeData.length > 0) {
                        var i;
                        for (i = 0; i <= storeData.length - 1; i++) {
                            $scope.StoreList.push(storeData[i]);
                        }
                    }
                    else {
                        $scope.lastStoreGeted = true;
                    }
                })
                .finally(function () {
                    $scope.$broadcast("scroll.infiniteScrollComplete");
                });
            }
        }
        //是否已经获得了最后一个店铺
        $scope.moreDataCanBeLoaded = function () {
            return !$scope.lastStoreGeted;
        }
        //更新我的消息数据
        $scope.updateMyMessageData = function () {
            if (UserSecurity.checked && $scope.keepMessageUpdate) {
                $http({ method: "POST", url: $rootScope._serverSvc + "getMemberLatestUnreadMessage", data: { 'mid': UserSecurity.mid, 'token': UserSecurity.token } })
                    .success(function (sdata) {
                        var messageInfo = JSON.parse(sdata.d);
                        if (messageInfo.status == "Exist") {
                            $rootScope._myMessageData.hasUnread = true;
                            var messageData = JSON.parse(messageInfo.value);
                            $rootScope._myMessageData.messageID = messageData.id;
                            $rootScope._myMessageData.createTime = messageData.name;
                        }
                        else {
                            $rootScope._myMessageData.hasUnread = false;
                        }
                    });
            }
        }
        //转到店铺详情
        $scope.goStoreDetail = function (storeID) {
            $ionicViewSwitcher.nextDirection("forward");
            $state.go("store-detail", { 'storeId': storeID });
        }
        //刷新位置
        $scope.refreshPosition = function () {
            if ($scope.valid.refreshPosition) {
                $scope.valid.refreshPosition = false;
                $scope.getPositionStart(
                    function (lat, lon) {
                        $scope.currentLocation = "正在解析地址...";
                        $scope.getLocationName(lat, lon,
                            function (locationName) {
                                $scope.currentLocation = locationName;
                            },
                            function (message) {
                                $scope.currentLocation = message;
                            });
                        $scope.getStoreList(function () {
                            $scope.valid.refreshPosition = true;
                        });
                    },
                    function (message) {
                        $scope.currentLocation = message;
                    });
            }
        }
        //转到搜索
        $scope.goSearch = function () {
            $ionicViewSwitcher.nextDirection("forward");
            $state.go("storeSearch");
        }
        //转到我的消息
        $scope.goMyMessage = function () {
            if (UserSecurity.checked) {
                $ionicViewSwitcher.nextDirection("forward");
                $state.go("myMessage");
            }
            else {
                $state.go("login");
            }
        }
        //转到手动定位
        $scope.goSelectPosition = function () {
            $ionicViewSwitcher.nextDirection("forward");
            $state.go("selectPosition");
        }

        $scope.initAppData();
        $scope.checkUserStatus(function () {
            $scope.getServiceType(function () {
                $scope.updateMyMessageData();
                $interval($scope.updateMyMessageData, 120000);
            });
        });

    })

    .controller('dealControl', function ($scope, $rootScope, $http, $state, $stateParams, UserLocation, UserSecurity, MD5Service) {
        $scope.$on('$ionicView.enter', function () {
            if (!UserSecurity.checked) {
                $state.go("login");
            }
            else {
                $scope.init();
            }
        });
        //初始化，检查是否传入TradingNo
        $scope.init = function () {
            $scope.buttonValid = { 'scanStart': true, 'addSelfTrading': true };
            $scope.divMessage = { 'div1': "", 'div2': "", 'div3': "", 'div4': "", 'div5': "" };
            $scope.input = { 'payPass': null, 'scoreCost': null, 'balanceCost': null, 'useScore': false, 'price': null, 'volume': null };
            $scope.storeData = {};
            $scope.tradingData = {};
            $scope.waitingDealList = [];
            if (typeof ($stateParams.tradingNo) == "undefined" || $stateParams.tradingNo == "" || $stateParams.tradingNo == "0" || $stateParams.tradingNo != $rootScope._dealParam) {
                $scope.divShow = { 'div1': true, 'div2': false, 'div3': false, 'div4': false, 'div5': false };
                $http({ method: "POST", url: $rootScope._serverSvc + "getPayMethod", data: {} })
                    .success(function (sdata) {
                        $scope.payMethods = JSON.parse(sdata.d);
                    });
            }
            else {
                $rootScope._dealParam = "0";
                $scope.divShow = { 'div1': false, 'div2': true, 'div3': false, 'div4': false, 'div5': false };
                $http({ method: "POST", url: $rootScope._serverSvc + "getPayMethod", data: {} })
                    .success(function (sdata) {
                        $scope.payMethods = JSON.parse(sdata.d);
                        $scope.showTradingDetail($stateParams.tradingNo);
                    });
            }
            $scope.getWaitingDealList();
        }
        //获取等待付款的交易列表
        $scope.getWaitingDealList = function () {
            $http({ method: "POST", url: $rootScope._serverSvc + "getMemberWaitingTradingList", data: { 'mid': UserSecurity.mid, 'token': UserSecurity.token } })
               .success(function (sdata) {
                   var tradingInfo = JSON.parse(sdata.d);
                   if (tradingInfo.status == "Done") {
                       if (tradingInfo.value == "{}") {
                           $scope.waitingDealList = [];
                       }
                       else {
                           $scope.waitingDealList = JSON.parse(tradingInfo.value);
                       }
                   }
                   else {
                       $scope.divMessage.div1 = tradingInfo.message;
                   }
               });
        }
        //打开摄像头，扫描二维码，获得TradingNo
        $scope.startScan = function () {
            if ($scope.buttonValid.scanStart) {
                $scope.buttonValid.scanStart = false;
                cordova.plugins.barcodeScanner.scan(
                    function (barcodeContent) {
                        $scope.buttonValid.scanStart = true;
                        if (barcodeContent.cancelled) {
                            $scope.$apply(function () {
                                $scope.divMessage.div1 = "扫描被取消";
                            });
                        }
                        else {
                            if (barcodeContent.format == "QR_CODE" && barcodeContent.text.length == 32) {
                                $scope.recogniseBarcode(barcodeContent.text);
                            }
                            else {
                                $scope.$apply(function () {
                                    $scope.divMessage.div1 = "扫描结果不是有效的交易码";
                                });
                            }
                        }
                    },
                    function (error) {
                        $scope.$apply(function () {
                            $scope.divMessage.div1 = error;
                        });
                    },
                    {
                        "preferFrontCamera": false, // iOS and Android
                        "showFlipCameraButton": false, // iOS and Android
                        "prompt": "请将条形码放置于框内", // supported on Android only
                        "formats": "QR_CODE" // default: all but PDF_417 and RSS_EXPANDED
                        //"orientation": "portrait" // Android only (portrait|landscape), default unset so it rotates with the device
                    });
            }
        }
        //判断二维码类型
        $scope.recogniseBarcode = function (barcodeText) {
            $http({ method: "POST", url: $rootScope._serverSvc + "recogniseTrading", data: { 'mid': UserSecurity.mid, 'token': UserSecurity.token, 'codeText': barcodeText } })
                .success(function (sdata) {
                    var serverData = JSON.parse(sdata.d);
                    if (serverData.status == "Done") {
                        var recogniseData = JSON.parse(serverData.value);
                        if (recogniseData.typeId == "1")//验证交易，不用再单独获取交易信息，直接转到交易详情
                        {
                            $scope.tradingData = recogniseData;
                            if ($scope.tradingData.payMethod == "") {
                                $scope.tradingData.payMethod = "1";//如果没有默认付款方式，则默认本土汇余额
                            }
                            $scope.divShow = { 'div1': false, 'div2': true, 'div3': false, 'div4': false, 'div5': false };//转到交易详情介面div2
                            $scope.input = { 'payPass': null, 'scoreCost': null, 'balanceCost': $scope.tradingData.volume, 'useScore': false, 'price': null, 'volume': null };
                            $scope.clearMessage();
                        }
                        else {
                            if (recogniseData.typeId == "2") {//自助交易，店铺信息已获取，转到显示店铺信息和输入价格
                                $scope.storeData = recogniseData;
                                $scope.divShow = { 'div1': false, 'div2': false, 'div3': false, 'div4': false, 'div5': true };
                            }
                            else {
                                $scope.divMessage.div1 = "无法识别的交易类型";
                            }
                        }
                    }
                    else {
                        $scope.divMessage.div1 = serverData.message;
                    }
                });
        }
        //增加自助交易单
        $scope.addSelfTrading = function () {
            if ($scope.buttonValid.addSelfTrading) {
                $scope.buttonValid.addSelfTrading = false;
                var storeID = $scope.storeData.sid;
                var price = $scope.input.price;
                if (price != null && Number(price) >= 0.1) {
                    $http({ method: "POST", url: $rootScope._serverSvc + "addSelfTrading", data: { 'mid': UserSecurity.mid, 'token': UserSecurity.token, 'sid': storeID, 'price': price } })
                        .success(function (sdata) {
                            var serverData = JSON.parse(sdata.d);
                            if (serverData.status == "Done") {
                                $scope.tradingData = JSON.parse(serverData.value);
                                if ($scope.tradingData.payMethod == "") {
                                    $scope.tradingData.payMethod = "1";//如果没有默认付款方式，则默认本土汇余额
                                }
                                $scope.divShow = { 'div1': false, 'div2': true, 'div3': false, 'div4': false, 'div5': false };//转到交易详情介面div2
                                $scope.input = { 'payPass': null, 'scoreCost': null, 'balanceCost': $scope.tradingData.volume, 'useScore': false, 'price': null, 'volume': null };
                                $scope.clearMessage();
                            }
                            else {
                                $scope.divMessage.div5 = serverData.message;
                            }
                            $scope.buttonValid.addSelfTrading = true;
                        });
                }
                else {
                    $scope.divMessage.div5 = "必须先输入一个有效的价格";
                    $scope.buttonValid.addSelfTrading = true;
                }
            }
        }
        //根据TradingNo获取交易信息，转到交易详情
        $scope.showTradingDetail = function (tradingNo) {
            $http({ method: "POST", url: $rootScope._serverSvc + "getMemberWaitingTradingDetail", data: { 'mid': UserSecurity.mid, 'token': UserSecurity.token, 'tn': tradingNo } })
                .success(function (sdata) {
                    var tradingInfo = JSON.parse(sdata.d);
                    if (tradingInfo.status == "Done") {
                        $scope.tradingData = JSON.parse(tradingInfo.value);
                        if ($scope.tradingData.payMethod == "") {
                            $scope.tradingData.payMethod = "1";//如果没有默认付款方式，则默认本土汇余额
                        }
                        $scope.divShow = { 'div1': false, 'div2': true, 'div3': false, 'div4': false, 'div5': false };//如果扫描成功且获取交易信息成功，转到交易详情介面div2
                        $scope.input = { 'payPass': null, 'scoreCost': null, 'balanceCost': $scope.tradingData.volume, 'useScore': false, 'price': null, 'volume': null };
                        $scope.clearMessage();
                    }
                    else {
                        $scope.divMessage.div1 = tradingInfo.message;
                    }
                });
        }
        //选择支付方式，进行支付准备
        $scope.payoffTrading = function () {
            if ($scope.tradingData.payMethod == 1) {//使用本土汇余额支付，打开支付密码输入界面div3
                $scope.divShow = { 'div1': false, 'div2': false, 'div3': true, 'div4': false };
                $scope.clearMessage();
            }
            else {//其他支付方式
                if ($scope.tradingData.payMethod == 2) {//如果使用支付宝支付
                    if ($scope.input.useScore) {
                        //如果使用了积分,进行付款准备
                        $http({ method: "POST", url: $rootScope._serverSvc + "updateTradingScore", data: { 'mid': UserSecurity.mid, 'token': UserSecurity.token, 'tn': $scope.tradingData.tradingNo, 'score': $scope.input.scoreCost } })
                            .success(function (sdata) {
                                var tradingInfo = JSON.parse(sdata.d);
                                if (tradingInfo.status == "Done") {
                                    if (tradingInfo.value == 0) {//如果还需要支付0元，直接完成交易
                                        $scope.addMemberEvent(7);
                                        $scope.divShow = { 'div1': false, 'div2': false, 'div3': false, 'div4': true, 'div5': false };//如果支付成功，转到成功祝贺介面div4
                                        $scope.clearMessage();
                                    }
                                    else {
                                        $scope.aliPayoff(tradingInfo.value);//支付宝支付剩余款项
                                    }
                                }
                                else {
                                    $scope.divMessage.div2 = tradingInfo.message;
                                }
                            });
                    }
                    else {//如果不使用积分
                        $scope.aliPayoff($scope.tradingData.volume);
                    }
                }
                else {
                    if ($scope.tradingData.payMethod == 3) {//如果使用微信支付
                        if ($scope.input.useScore) {
                            //如果使用了积分,进行付款准备
                            $http({ method: "POST", url: $rootScope._serverSvc + "updateTradingScore", data: { 'mid': UserSecurity.mid, 'token': UserSecurity.token, 'tn': $scope.tradingData.tradingNo, 'score': $scope.input.scoreCost } })
                                .success(function (sdata) {
                                    var tradingInfo = JSON.parse(sdata.d);
                                    if (tradingInfo.status == "Done") {
                                        if (tradingInfo.value == 0) {//如果还需要支付0元，直接完成交易
                                            $scope.divShow = { 'div1': false, 'div2': false, 'div3': false, 'div4': true, 'div5': false };//如果支付成功，转到成功祝贺介面div4
                                            $scope.clearMessage();
                                        }
                                        else {
                                            $scope.wechatPayoff(tradingInfo.value);//微信支付剩余款项
                                        }
                                    }
                                    else {
                                        $scope.divMessage.div2 = tradingInfo.message;
                                    }
                                });
                        }
                        else {//如果不使用积分，直接微信支付
                            $scope.wechatPayoff($scope.tradingData.volume);
                        }
                    }
                }
            }
        }
        //余额支付
        $scope.balancePayoff = function (payPass) {//所有验证完成后，执行余额付款
            var scoreCost;
            if ($scope.input.useScore) {
                scoreCost = $scope.input.scoreCost
            }
            else {
                scoreCost = 0;
            }
            $http({ method: "POST", url: $rootScope._serverSvc + "payoffTrading", data: { 'mid': UserSecurity.mid, 'token': UserSecurity.token, 'payPass': payPass, 'tn': $scope.tradingData.tradingNo, 'score': scoreCost } })
                .success(function (sdata) {
                    payoffInfo = JSON.parse(sdata.d);
                    if (payoffInfo.status == "Done") {
                        $scope.addMemberEvent(2);
                        $scope.divShow = { 'div1': false, 'div2': false, 'div3': false, 'div4': true, 'div5': false };//如果支付成功，转到成功祝贺介面div4
                        $scope.clearMessage();
                    }
                    else {
                        $scope.divMessage.div3 = payoffInfo.message;
                    }
                    $scope.input.payPass = "";
                });
        }
        //支付宝支付
        $scope.aliPayoff = function (thirdVolume) {
            try {
                window.alipay.pay({
                    tradeNo: $scope.tradingData.tradingNo,
                    subject: "本土汇-由" + $scope.tradingData.storeName + "发起-收款",
                    body: "消费支付",
                    price: thirdVolume,
                    notifyUrl: $rootScope._alipayTradeNotifyUrl
                },
                function (successResults) {
                    $scope.addMemberEvent(3);
                    $scope.$apply(function () {
                        $scope.divShow = { 'div1': false, 'div2': false, 'div3': false, 'div4': true, 'div5': false };//如果支付成功，转到成功祝贺介面div4
                    })
                },
                function (errorResults) {
                    if (errorResults) {
                        $scope.$apply(function () {
                            $scope.divMessage.div2 = errorResults.memo;
                        })
                    }
                });
            }
            catch (ex) {
                $scope.divMessage.div2 = ex.message;
            }
        }
        //微信支付
        $scope.wechatPayoff = function (thirdVolume) {
            $http({ method: "POST", url: $rootScope._serverSvc + "getTradingWechatPrepayCode", data: { 'mid': UserSecurity.mid, 'token': UserSecurity.token, 'tn': $scope.tradingData.tradingNo, 'thirdVolume': thirdVolume, 'payDescription': "本土汇-由" + $scope.tradingData.storeName + "发起-收款" } })
                .success(function (sdata) {
                    var tradingInfo = JSON.parse(sdata.d);
                    if (tradingInfo.status == "Done") {
                        var wechatData = JSON.parse(tradingInfo.value);
                        var params = {
                            partnerid: '1380087902', // merchant id
                            prepayid: wechatData.prepayid, // prepay id
                            noncestr: wechatData.noncestr, // nonce
                            timestamp: wechatData.timestamp, // timestamp
                            sign: wechatData.sign // signed string
                        };
                        try {
                            Wechat.sendPaymentRequest(params, function () {
                                $scope.addMemberEvent(4);
                                $scope.$apply(function () {
                                    $scope.divShow = { 'div1': false, 'div2': false, 'div3': false, 'div4': true, 'div5': false };//如果支付成功，转到成功祝贺介面div4
                                })
                            }, function (reason) {
                                if (reason) {
                                    $scope.$apply(function () {
                                        $scope.divMessage.div2 = reason;
                                    })
                                }
                            });
                        }
                        catch (ex) {
                            $scope.divMessage.div2 = ex.message;
                        }
                    }
                    else {
                        $scope.divMessage.div2 = tradingInfo.message;
                    }
                });

        }
        ////////这里添加其他第三方支付方法//////////

        //发送会员事件
        $scope.addMemberEvent = function (type) {
            $http({ method: "POST", url: $rootScope._serverSvc + "addMemberEvent", data: { 'mid': UserSecurity.mid, 'token': UserSecurity.token, 'type': type, 'locationX': UserLocation.realX, 'locationY': UserLocation.realY, 'uuid': $rootScope._uuid, 'remark': $scope.tradingData.tradingNo } })
                .success(function (sdata) { });
        }
        //检查支付密码合法性
        $scope.checkPayPass = function () {
            $scope.divMessage.div3 = "";
            var payPass = String($scope.input.payPass);
            if (payPass.length == 6) {
                $scope.balancePayoff(MD5Service.hex_md5(payPass));
            }
        }
        //检查积分输入合法性
        $scope.checkScore = function () {
            if ($scope.input.scoreCost == null || isNaN($scope.input.scoreCost)) {
                $scope.input.balanceCost = $scope.tradingData.volume;
            }
            else {
                var score, scoreCost, price, volume, discount, scoreRate, balanceCost;
                score = parseInt($scope.tradingData.score);
                scoreCost = parseInt($scope.input.scoreCost);
                if (scoreCost > score) {
                    scoreCost = score;
                }
                discount = parseInt($scope.tradingData.discount);
                price = Number($scope.tradingData.price);
                volume = Number($scope.tradingData.volume);
                scoreRate = Number($scope.tradingData.scoreRate);
                balanceCost = ((price - scoreCost * scoreRate) * discount / 100).toFixed(2);
                if (balanceCost < 0) {
                    balanceCost = 0;
                    scoreCost = Math.ceil(price / scoreRate)
                }
                $scope.input.scoreCost = scoreCost;
                $scope.input.balanceCost = balanceCost;
            }
        }
        //检查使用积分复选框
        $scope.checkUseScore = function () {
            if (!$scope.input.useScore) {
                $scope.input.scoreCost = "";
                $scope.input.balanceCost = $scope.tradingData.volume;
            }
        }
        //检查价格输入
        $scope.checkPrice = function () {
            var str = String($scope.input.price);
            var count = str.indexOf(".");
            var price;
            if (count != -1 && count >= str.length - 3) {
                $scope.input.price = Number(str.substr(0, count + 2));
            }
            if ($scope.input.price != "") {
                price = Number($scope.input.price);
                if (isNaN(price) || price < 0.1) {
                    $scope.input.volume = "";
                }
                else {
                    $scope.input.volume = (Number(price) * Number($scope.storeData.discount) / 100).toFixed(2);
                    $scope.divMessage.div5 = "";
                }
            }
        }
        //回退
        $scope.goBack = function () {
            if ($scope.divShow.div3) {
                $scope.divShow = { 'div1': false, 'div2': true, 'div3': false, 'div4': false, 'div5': false };
            }
            else {
                $scope.divShow = { 'div1': true, 'div2': false, 'div3': false, 'div4': false, 'div5': false };
                $scope.getWaitingDealList();
            }
            $scope.clearMessage();
        }
        //清除消息
        $scope.clearMessage = function () {
            $scope.divMessage = { 'div1': "", 'div2': "", 'div3': "", 'div4': "", 'div5': "" };
        }
    })

    .controller('findControl', function ($scope, $rootScope, $http, $state, UserSecurity) {
        $scope.$on('$ionicView.enter', function () {
            if (!UserSecurity.checked) {
                $state.go("login");
            }
        });
        $scope.init = function () {
            $scope.divShow = { 'div1': true, 'div2': false, 'div3': false };
            $scope.message = { 'div1': "", 'div2': "", 'buttonText': "" };
            $scope.valid = { 'update': true };
            $scope.buttonShow = { 'goto': false, 'update': false };
            $scope.currentMission = {};
            $scope.getMissionList();
        }
        $scope.getMissionList = function () {
            $http({ method: "POST", url: $rootScope._serverSvc + "getMissionList", data: { 'mid': UserSecurity.mid, 'token': UserSecurity.token } })
                .success(function (sdata) {
                    var missionInfo = JSON.parse(sdata.d);
                    if (missionInfo.status == "Done") {
                        $scope.missionList = JSON.parse(missionInfo.value);
                    }
                });
        }
        $scope.goMissionDetail = function (missionItem) {
            $scope.currentMission = missionItem;
            $scope.divShow = { 'div1': false, 'div2': true, 'div3': false };
            $scope.checkMission();
        }
        $scope.checkMission = function () {
            $http({ method: "POST", url: $rootScope._serverSvc + "checkMissionCondition", data: { 'mid': UserSecurity.mid, 'token': UserSecurity.token, 'missionID': $scope.currentMission.id } })
                .success(function (sdata) {
                    var missionInfo = JSON.parse(sdata.d);
                    if (missionInfo.status == "Done") {
                        var missionStatus = JSON.parse(missionInfo.value);
                        $scope.message.div2 = missionStatus.message1;
                        $scope.message.buttonText = missionStatus.buttonName;
                        if (missionStatus.statusType == 1) {//未完成任务，未领取奖励
                            $scope.currentMission.stateName = missionStatus.stateName;
                            if (typeof ($scope.currentMission.stateName) != "undefined" && $scope.currentMission.stateName.length >= 4) {
                                $scope.buttonShow.goto = true;
                            }
                        }
                        if (missionStatus.statusType == 2) {//已完成任务，未领取奖励
                            $scope.buttonShow.update = true;
                        }
                    }
                    else {
                        $scope.message.div2 = missionInfo.message;
                    }
                });
        }
        $scope.goState = function () {
            if (typeof ($scope.currentMission.stateName) != "undefined" && $scope.currentMission.stateName.length >= 4) {
                $state.go($scope.currentMission.stateName);
            }
            else {
                $scope.message.div2 = "无法跳转到任务页，任务信息不明确";
            }
        }
        $scope.updateMission = function () {
            if ($scope.valid.update) {
                $scope.valid.update = false;
                $http({ method: "POST", url: $rootScope._serverSvc + "updateMissionData", data: { 'mid': UserSecurity.mid, 'token': UserSecurity.token, 'missionID': $scope.currentMission.id } })
                    .success(function (sdata) {
                        var missionInfo = JSON.parse(sdata.d);
                        if (missionInfo.status == "Done") {
                            var missionStatus = JSON.parse(missionInfo.value);
                            $scope.currentMission.message1 = missionStatus.message1;
                            $scope.currentMission.message2 = missionStatus.message2;
                            $scope.currentMission.message3 = missionStatus.message3;
                            $scope.currentMission.message4 = missionStatus.message4;
                            $scope.divShow = { 'div1': false, 'div2': false, 'div3': true };
                            $scope.getMissionList();
                        }
                        else {
                            if (missionInfo.value != "") {
                                var missionStatus = JSON.parse(missionInfo.value);
                                $scope.message.div2 = missionStatus.message1;
                                $scope.message.buttonText = missionStatus.buttonName;
                                if (missionStatus.statusType == 1) {//未完成任务，未领取奖励
                                    $scope.currentMission.stateName = missionStatus.stateName;
                                    if (typeof ($scope.currentMission.stateName) != "undefined" && $scope.currentMission.stateName.length >= 4) {
                                        $scope.buttonShow.goto = true;
                                    }
                                }
                                if (missionStatus.statusType == 2) {//已完成任务，未领取奖励
                                    $scope.buttonShow.update = true;
                                }
                            }
                            else {
                                $scope.message.div2 = missionInfo.message;
                            }
                        }
                    });
            }
        }
        $scope.goDraw = function () {
            $state.go("boxDraw");
        }
        $scope.goBack = function () {
            $scope.divShow = { 'div1': true, 'div2': false, 'div3': false };
            $scope.message = { 'div1': "", 'div2': "", 'buttonText': "" };
            $scope.valid = { 'update': true };
            $scope.buttonShow = { 'goto': false, 'update': false };
            $scope.currentMission = {};
        }
        $scope.init();

    })

    .controller('mineControl', function ($scope, $rootScope, $state, $http, $ionicViewSwitcher, UserSecurity, UserPersonal) {
        $scope.$on('$ionicView.enter', function () {
            $scope.user = { 'mid': UserSecurity.mid, 'token': UserSecurity.token };
            if (!UserSecurity.checked) {
                $state.go("login");
            }
            else {
                $scope.init();
            }
        });
        $scope.init = function () {
            $scope.userPersonal = null;
            $http({ method: "POST", url: $rootScope._serverSvc + "getMemberInfo", data: { 'mid': UserSecurity.mid, 'token': UserSecurity.token } })
                .success(function (sdata) {
                    if (sdata.d == "{}") {
                        $scope.userPersonal = null;
                        UserSecurity.checked = false;
                        $state.go("login");
                    }
                    else {
                        var userPersonalData = JSON.parse(sdata.d);
                        $rootScope._memberInfo.balanceNum = userPersonalData.balance;
                        $rootScope._memberInfo.scoreNum = userPersonalData.score;
                        $rootScope._memberInfo.keyNum = userPersonalData.boxKey;
                        if (userPersonalData.headImage == "") {
                            userPersonalData.headImage = "Images/App/Users/defaultHeadImage.png";
                        }
                        $scope.userPersonal = userPersonalData;
                    }
                });
        }
        $scope.goMyHeadImage = function () {
            $ionicViewSwitcher.nextDirection("forward");
            $state.go('myHeadImage');
        }
        $scope.goRecharge = function () {
            $ionicViewSwitcher.nextDirection("forward");
            $state.go('recharge');
        }
        $scope.goScoreExchange = function () {
            $ionicViewSwitcher.nextDirection("forward");
            $state.go('scoreExchange');
        }
        $scope.goBoxDraw = function () {
            $ionicViewSwitcher.nextDirection("forward");
            $state.go('boxDraw');
        }
        $scope.openJoinPage = function () {
            cordova.InAppBrowser.open("http://www.bentuhui.com/join.html", '_blank', 'location=no');
        }
    })

    .controller('loginControl', function ($scope, $rootScope, $http, $state, $window, UserSecurity) {
        $scope.doLogin = function () {
            var account = String($scope.userAccount);
            var password = String($scope.userPassword);
            if (account.length < 6 || password.length < 6) {
                $scope.errorMessage = "请输入有效的用户名和密码";
            }
            else {
                $http({ method: "POST", url: $rootScope._serverSvc + "loginMember", data: { 'account': account, 'password': password, 'uuid': $rootScope._uuid } })
                .success(function (sdata) {
                    var loginData = JSON.parse(sdata.d);
                    if (loginData.status == "Done") {
                        var valueData = JSON.parse(loginData.value);
                        UserSecurity.mid = valueData.mid;
                        UserSecurity.token = valueData.token;
                        UserSecurity.cellNumber = valueData.cellNumber;
                        UserSecurity.checked = true;
                        $window.localStorage['linkerUser'] = loginData.value;
                        $state.go("tab.mine");
                    }
                    else {
                        $scope.errorMessage = loginData.message;
                    }
                })
            }
        }
        $scope.wechatLogin = function () {
            var scope = "snsapi_userinfo";
            var state = "_" + (+new Date());
            Wechat.auth(scope, state, function (response) {
                // you may use response.code to get the access token.
                console.log(response);
            }, function (reason) {
                alert("Failed: " + reason);
            });
        }
    })

    .controller('logoutControl', function ($scope, $rootScope, $http, $state, $window, $ionicHistory, $ionicViewSwitcher, UserSecurity) {
        $scope.doLogout = function () {
            $window.localStorage['linkerUser'] = "";
            UserSecurity.mid = "";
            UserSecurity.token = "";
            UserSecurity.cellNumber = "";
            UserSecurity.checked = false;
            if ($rootScope._platform == "IOS") {
                ionic.Platform.exitApp();
            }
            else {
                $ionicHistory.clearCache();
            }
            $ionicViewSwitcher.nextDirection("back");
            $state.go("tab.home");
        }
    })

    .controller('registerControl', function ($scope, $rootScope, $http, $state, $interval, $ionicViewSwitcher) {
        $scope.init = function () {
            $scope.timerCount = 0;
            $scope.MessageButtonText = "获取验证码";
            $scope.buttonShow = { 'commit': true }
            $scope.buttonValid = { 'commit': true, 'sendMessage': true };
            $scope.input = { 'userAccount': "", 'userPassword': "", 'userPassword2': "", 'userPayPassword': "", 'userPayPassword2': "", 'userCellNumber': "", 'userName': "", 'userMessageConfrim': "", 'userReference': "" };
            $scope.message = { 'accountError': "", 'passwordError': "", 'passwordError2': "", 'payPasswordError': "", 'payPasswordError2': "", 'cellNumberError': "", 'messageConfrimError': "", 'messageConfrimSuccess': "", 'commitError': "", 'commitSuccess': "", 'referenceError': "" };
        }
        $scope.timerOnce = function () {
            $scope.MessageButtonText = $scope.timerCount + 's';
            if ($scope.timerCount > 0) {
                $scope.timerCount--;
            }
        }
        $scope.timerEnd = function () {
            $scope.timerCount = 0;
            $scope.MessageButtonText = "获取验证码";
        }
        $scope.doCommit = function () {
            if ($scope.buttonValid.commit) {
                $scope.buttonValid.commit = false;
                $scope.checkAccount(function () {
                    $scope.checkPassword(function () {
                        $scope.checkPassword2(function () {
                            $scope.checkPayPassword(function () {
                                $scope.checkPayPassword2(function () {
                                    $scope.checkCellNumber(function () {
                                        $scope.checkMessageConfrim(function () {
                                            $scope.checkReference(function () {
                                                $http({ method: "POST", url: $rootScope._serverSvc + "addMember", data: { 'account': $scope.input.userAccount, 'password': $scope.input.userPassword, 'payPassword': $scope.input.userPayPassword, 'name': $scope.input.userName, 'cellNumber': $scope.input.userCellNumber, 'confrimCode': $scope.input.userMessageConfrim, 'reference': $scope.input.userReference } })
                                                .success(function (sdata) {
                                                    var registerData = JSON.parse(sdata.d);
                                                    if (registerData.status == "Done") {
                                                        $scope.init();
                                                        $scope.buttonShow.commit = false;
                                                        $scope.message.commitSuccess = "恭喜您注册成功！为避免忘记您的账号密码，现在就去登录页登录吧";
                                                    }
                                                    else {
                                                        $scope.message.commitError = registerData.message;
                                                        $scope.message.commitSuccess = "";
                                                        $scope.message.messageConfrimSuccess = "";
                                                        $scope.message.messageConfrimError = "";
                                                    }
                                                    $scope.buttonValid.commit = true;
                                                });
                                            }, function () {
                                                $scope.buttonValid.commit = true;
                                            });
                                        }, function () {
                                            $scope.buttonValid.commit = true;
                                        });
                                    }, function () {
                                        $scope.buttonValid.commit = true;
                                    });
                                }, function () {
                                    $scope.buttonValid.commit = true;
                                });
                            }, function () {
                                $scope.buttonValid.commit = true;
                            });
                        }, function () {
                            $scope.buttonValid.commit = true;
                        });
                    }, function () {
                        $scope.buttonValid.commit = true;
                    });
                }, function () {
                    $scope.buttonValid.commit = true;
                });
            }
        }
        $scope.getMessageConfrim = function () {
            if ($scope.timerCount == 0 && $scope.buttonValid.sendMessage) {
                $scope.buttonValid.sendMessage = false;
                $scope.checkCellNumber(function () {
                    $http({ method: "POST", url: $rootScope._serverSvc + "sendMemberRegisterConfrimCode", data: { 'cellNumber': $scope.input.userCellNumber } })
                    .success(function (sdata) {
                        $scope.buttonValid.sendMessage = true;
                        var confrimData = JSON.parse(sdata.d);
                        if (confrimData.status == "Done") {
                            $scope.message.messageConfrimSuccess = "短信验证码发送成功，请在十分钟内填写并提交资料";
                            $scope.message.messageConfrimError = "";
                            $scope.message.commitError = "";
                            $scope.message.commitSuccess = "";
                            $scope.timerCount = 120;
                            $interval($scope.timerOnce, 1000, $scope.timerCount).then($scope.timerEnd);
                        }
                        else {
                            $scope.message.messageConfrimError = confrimData.message;
                            $scope.message.messageConfrimSuccess = "";
                            $scope.message.commitError = "";
                            $scope.message.commitSuccess = "";
                        }
                    });
                }, function () {
                    $scope.buttonValid.sendMessage = true;
                }
                );
            }
        }
        $scope.checkAccount = function (callback, callbackError) {
            var account = String($scope.input.userAccount);
            var re = new RegExp("^[a-zA-Z]");
            if (account.length >= 6 && re.test(account)) {
                $http({ method: "POST", url: $rootScope._serverSvc + "checkMemberAccount", data: { 'account': account } })
                .success(function (sdata) {
                    var accountData = JSON.parse(sdata.d);
                    if (accountData.status == "Done") {
                        $scope.message.accountError = "";
                        if (typeof (callback) == "function") {
                            callback();
                        }
                    }
                    else {
                        $scope.message.accountError = accountData.message;
                        if (typeof (callbackError) == "function") {
                            callbackError();
                        }
                    }
                });
            }
            else {
                $scope.message.accountError = "请使用6个字符以上的用户名且必须以字母开头";
                if (typeof (callbackError) == "function") {
                    callbackError();
                }
            }
        }
        $scope.checkPassword = function (callback, callbackError) {
            var password = String($scope.input.userPassword);
            if (password.length >= 6) {
                $scope.message.passwordError = "";
                if (typeof (callback) == "function") {
                    callback();
                }
            }
            else {
                $scope.message.passwordError = "请使用6个字符以上的密码并包含字母和数字";
                if (typeof (callbackError) == "function") {
                    callbackError();
                }
            }
        }
        $scope.checkPassword2 = function (callback, callbackError) {
            if ($scope.input.userPassword === $scope.input.userPassword2) {
                $scope.message.passwordError2 = "";
                if (typeof (callback) == "function") {
                    callback();
                }
            }
            else {
                $scope.message.passwordError2 = "两次密码输入不一致";
                if (typeof (callbackError) == "function") {
                    callbackError();
                }
            }
        }
        $scope.checkPayPassword = function (callback, callbackError) {
            var payPass = String($scope.input.userPayPassword);
            var re = new RegExp("[0-9]{6}");
            if (payPass.length == 6 && re.test(payPass)) {
                $scope.message.payPasswordError = "";
                if (typeof (callback) == "function") {
                    callback();
                }
            }
            else {
                $scope.message.payPasswordError = "支付密码必须是6位数字";
                if (typeof (callbackError) == "function") {
                    callbackError();
                }
            }
        }
        $scope.checkPayPassword2 = function (callback, callbackError) {
            if ($scope.input.userPayPassword === $scope.input.userPayPassword2) {
                $scope.message.payPasswordError2 = "";
                if (typeof (callback) == "function") {
                    callback();
                }
            }
            else {
                $scope.message.payPasswordError2 = "两次支付密码输入不一致";
                if (typeof (callbackError) == "function") {
                    callbackError();
                }
            }
        }
        $scope.checkCellNumber = function (callback, callbackError) {
            var cellNumber = String($scope.input.userCellNumber);
            var re = new RegExp("1[0-9]{10}");
            if (cellNumber.length == 11 && re.test(cellNumber)) {
                $http({ method: "POST", url: $rootScope._serverSvc + "checkMemberPhoneNumber", data: { 'cellNumber': cellNumber } })
                .success(function (sdata) {
                    var cellNumberData = JSON.parse(sdata.d);
                    if (cellNumberData.status == "Done") {
                        $scope.message.cellNumberError = "";
                        if (typeof (callback) == "function") {
                            callback();
                        }
                    }
                    else {
                        $scope.message.cellNumberError = cellNumberData.message;
                        if (typeof (callbackError) == "function") {
                            callbackError();
                        }
                    }
                });
            }
            else {
                $scope.message.cellNumberError = "手机号码格式不正确";
                if (typeof (callbackError) == "function") {
                    callbackError();
                }
            }
        }
        $scope.checkMessageConfrim = function (callback, callbackError) {
            var confrimCode = String($scope.input.userMessageConfrim);
            var re = new RegExp("[0-9]{6}");
            if (confrimCode.length == 6 && re.test(confrimCode)) {
                $scope.message.messageConfrimError = "";
                if (typeof (callback) == "function") {
                    callback();
                }
            }
            else {
                $scope.message.messageConfrimError = "验证码是6位数字";
                if (typeof (callbackError) == "function") {
                    callbackError();
                }
            }
        }
        $scope.checkReference = function (callback, callbackError) {
            var cellNumber = String($scope.input.userReference);
            var re = new RegExp("1[0-9]{10}");
            if (cellNumber == "" || ($scope.input.userCellNumber != $scope.input.userReference && cellNumber.length == 11 && re.test(cellNumber))) {
                $scope.message.referenceError = "";
                if (typeof (callback) == "function") {
                    callback();
                }
            }
            else {
                $scope.message.referenceError = "推荐人手机号码格式不正确";
                if (typeof (callbackError) == "function") {
                    callbackError();
                }
            }
        }
        $scope.goLogin = function () {
            $ionicViewSwitcher.nextDirection("back");
            $state.go("login");
        }
        $scope.init();
    })

    .controller('retrievePasswordControl', function ($scope, $rootScope, $http, $state, $interval, $ionicViewSwitcher, UserLocation) {
        $scope.init = function () {
            $scope.timerCount = 0;
            $scope.MessageButtonText = "获取验证码";
            $scope.buttonShow = { 'commit': true }
            $scope.buttonValid = { 'commit': true, 'sendMessage': true };
            $scope.input = { 'userAccount': "", 'userCellNumber': "", 'userPassword': "", 'userPassword2': "", 'userMessageConfrim': "" };
            $scope.message = { 'accountError': "", 'passwordError': "", 'passwordError2': "", 'cellNumberError': "", 'messageConfrimError': "", 'messageConfrimSuccess': "", 'commitError': "", 'commitSuccess': "" };
        }
        $scope.timerOnce = function () {
            $scope.MessageButtonText = $scope.timerCount + 's';
            if ($scope.timerCount > 0) {
                $scope.timerCount--;
            }
        }
        $scope.timerEnd = function () {
            $scope.timerCount = 0;
            $scope.MessageButtonText = "获取验证码";
        }
        $scope.doReset = function () {
            if ($scope.buttonValid.commit) {
                $scope.buttonValid.commit = false;
                $scope.checkAccount(function () {
                    $scope.checkPassword(function () {
                        $scope.checkPassword2(function () {
                            $scope.checkCellNumber(function () {
                                $scope.checkMessageConfrim(function () {
                                    $http({ method: "POST", url: $rootScope._serverSvc + "resetMemberPassword", data: { 'account': $scope.input.userAccount, 'cellNumber': $scope.input.userCellNumber, 'confrimCode': $scope.input.userMessageConfrim, 'newPassword': $scope.input.userPassword, 'locationX': UserLocation.realX, 'locationY': UserLocation.realY, 'uuid': $rootScope._uuid } })
                                    .success(function (sdata) {
                                        var registerData = JSON.parse(sdata.d);
                                        if (registerData.status == "Done") {
                                            $scope.init();
                                            $scope.buttonShow.commit = false;
                                            $scope.message.commitSuccess = "重置密码成功,您现在可以用新密码登录了";
                                        }
                                        else {
                                            $scope.message.commitError = registerData.message;
                                            $scope.message.commitSuccess = "";
                                            $scope.message.messageConfrimSuccess = "";
                                            $scope.message.messageConfrimError = "";
                                        }
                                        $scope.buttonValid.commit = true;
                                    });
                                }, function () {
                                    $scope.buttonValid.commit = true;
                                });
                            }, function () {
                                $scope.buttonValid.commit = true;
                            });
                        }, function () {
                            $scope.buttonValid.commit = true;
                        });
                    }, function () {
                        $scope.buttonValid.commit = true;
                    });
                }, function () {
                    $scope.buttonValid.commit = true;
                });
            }
        }
        $scope.getMessageConfrim = function () {
            if ($scope.timerCount == 0 && $scope.buttonValid.sendMessage) {
                $scope.buttonValid.sendMessage = false;
                $scope.checkCellNumber(function () {
                    $http({ method: "POST", url: $rootScope._serverSvc + "sendMemberResetPasswordConfrimCode", data: { 'cellNumber': $scope.input.userCellNumber } })
                    .success(function (sdata) {
                        var confrimData = JSON.parse(sdata.d);
                        if (confrimData.status == "Done") {
                            $scope.message.messageConfrimSuccess = "短信验证码发送成功，请在十分钟内填写并提交资料";
                            $scope.message.messageConfrimError = "";
                            $scope.message.commitError = "";
                            $scope.message.commitSuccess = "";
                            $scope.timerCount = 120;
                            $interval($scope.timerOnce, 1000, $scope.timerCount).then($scope.timerEnd);
                        }
                        else {
                            $scope.message.messageConfrimError = confrimData.message;
                            $scope.message.messageConfrimSuccess = "";
                            $scope.message.commitError = "";
                            $scope.message.commitSuccess = "";
                        }
                        $scope.buttonValid.sendMessage = true;
                    });
                }, function () {
                    $scope.buttonValid.sendMessage = true;
                });
            }
        }
        $scope.checkAccount = function (callback, callbackError) {
            var account = String($scope.input.userAccount);
            var re = new RegExp("^[a-zA-Z]");
            if (account.length >= 6 && re.test(account)) {
                $scope.message.accountError = "";
                if (typeof (callback) == "function") {
                    callback();
                }
            }
            else {
                $scope.message.accountError = "请使用6个字符以上的用户名且必须以字母开头";
                if (typeof (callbackError) == "function") {
                    callbackError();
                }
            }
        }
        $scope.checkCellNumber = function (callback, callbackError) {
            var cellNumber = String($scope.input.userCellNumber);
            var re = new RegExp("1[0-9]{10}");
            if (cellNumber.length == 11 && re.test(cellNumber)) {
                $scope.message.cellNumberError = "";
                if (typeof (callback) == "function") {
                    callback();
                }
            }
            else {
                $scope.message.cellNumberError = "手机号码格式不正确";
                if (typeof (callbackError) == "function") {
                    callbackError();
                }
            }
        }
        $scope.checkPassword = function (callback, callbackError) {
            var password = String($scope.input.userPassword);
            if (password.length >= 6) {
                $scope.message.passwordError = "";
                if (typeof (callback) == "function") {
                    callback();
                }
            }
            else {
                $scope.message.passwordError = "请使用6个字符以上的密码并包含字母和数字";
                if (typeof (callbackError) == "function") {
                    callbackError();
                }
            }
        }
        $scope.checkPassword2 = function (callback, callbackError) {
            if ($scope.input.userPassword === $scope.input.userPassword2) {
                $scope.message.passwordError2 = "";
                if (typeof (callback) == "function") {
                    callback();
                }
            }
            else {
                $scope.message.passwordError2 = "两次密码输入不一致";
                if (typeof (callbackError) == "function") {
                    callbackError();
                }
            }
        }
        $scope.checkMessageConfrim = function (callback, callbackError) {
            var confrimCode = String($scope.input.userMessageConfrim);
            var re = new RegExp("[0-9]{6}");
            if (confrimCode.length == 6 && re.test(confrimCode)) {
                $scope.message.messageConfrimError = "";
                if (typeof (callback) == "function") {
                    callback();
                }
            }
            else {
                $scope.message.messageConfrimError = "验证码是6位数字";
                if (typeof (callbackError) == "function") {
                    callbackError();
                }
            }
        }
        $scope.goLogin = function () {
            $ionicViewSwitcher.nextDirection("back");
            $state.go("login");
        }
        $scope.init();
    })

    .controller('rechargeControl', function ($scope, $rootScope, $http, $state, $ionicHistory, $ionicViewSwitcher, UserSecurity) {
        //初始化
        $scope.init = function () {
            $scope.divShow = { "div1": true, "div2": false };
            $scope.message = { "error": "" };
            $scope.input = { "rechargeVolume": "" };
            $scope.valid = { 'commit': true };
            $scope.rechargeData = { "rechargeMethod": "", "rechargeNo": "", "rechargeVolume": 0 };
            $http({ method: "POST", url: $rootScope._serverSvc + "getRechargeMethod", data: {} })
                .success(function (sdata) {
                    $scope.rechargeMethods = JSON.parse(sdata.d);
                    $scope.rechargeData.rechargeMethod = $scope.rechargeMethods[0].id;
                });
        }
        //检查充值金额
        $scope.checkVolume = function () {
            var str = String($scope.input.rechargeVolume);
            var count = str.indexOf(".");
            console.log(count);
            if (count != -1) {
                $scope.input.rechargeVolume = Number(str.substr(0, count));
            }
        }
        //充值
        $scope.doCommit = function () {
            if ($scope.valid.commit) {
                $scope.valid.commit = false;
                $scope.checkVolume();
                $scope.rechargeData.rechargeVolume = Number($scope.input.rechargeVolume);
                if ($scope.rechargeData.rechargeVolume < 10) {
                    $scope.message.error = "充值金额不能少于10元";
                    return;
                }
                $http({ method: "POST", url: $rootScope._serverSvc + "addMemberRecharge", data: { "mid": UserSecurity.mid, "token": UserSecurity.token, "type": "2", "volume": $scope.rechargeData.rechargeVolume } })
                    .success(function (sdata) {
                        var rechargeInfo = JSON.parse(sdata.d);
                        if (rechargeInfo.status == "Done") {
                            $scope.rechargeData.rechargeNo = rechargeInfo.value;
                            if ($scope.rechargeData.rechargeMethod == 2) {//支付宝充值
                                try {
                                    window.alipay.pay({
                                        tradeNo: $scope.rechargeData.rechargeNo,
                                        subject: "本土汇-充值",
                                        body: "充值支付",
                                        price: $scope.rechargeData.rechargeVolume,
                                        notifyUrl: $rootScope._alipayChargeNotifyUrl
                                    },
                                    function (successResults) {
                                        $scope.$apply(function () {
                                            $scope.divShow = { "div1": false, "div2": true };//如果支付成功，转到成功祝贺介面div2
                                            $scope.input.rechargeVolume = "";
                                            $scope.valid.commit = true;
                                        })
                                    },
                                    function (errorResults) {
                                        if (errorResults) {
                                            $scope.$apply(function () {
                                                $scope.message.error = errorResults.memo;
                                                $scope.valid.commit = true;
                                            })
                                        }
                                    });
                                }
                                catch (ex) {
                                    $scope.message.error = ex.message;
                                }
                            }
                            else {
                                if ($scope.rechargeData.rechargeMethod == 3) {//微信支付
                                    $http({ method: "POST", url: $rootScope._serverSvc + "getRechargeWechatPrepayCode", data: { 'mid': UserSecurity.mid, 'token': UserSecurity.token, 'tn': $scope.rechargeData.rechargeNo, 'thirdVolume': $scope.rechargeData.rechargeVolume, 'payDescription': "本土汇-充值" } })
                                        .success(function (sdata) {
                                            var wechatInfo = JSON.parse(sdata.d);
                                            console.log(wechatInfo);
                                            if (wechatInfo.status == "Done") {
                                                var wechatData = JSON.parse(wechatInfo.value);
                                                var params = {
                                                    partnerid: '1380087902', // merchant id
                                                    prepayid: wechatData.prepayid, // prepay id
                                                    noncestr: wechatData.noncestr, // nonce
                                                    timestamp: wechatData.timestamp, // timestamp
                                                    sign: wechatData.sign // signed string
                                                };
                                                try {
                                                    Wechat.sendPaymentRequest(params, function () {
                                                        console.log("Success");
                                                        $scope.$apply(function () {
                                                            $scope.divShow = { "div1": false, "div2": true };//如果支付成功，转到成功祝贺介面div2
                                                            $scope.input.rechargeVolume = "";
                                                            $scope.valid.commit = true;
                                                        })
                                                    }, function (reason) {
                                                        console.log(reason);
                                                        if (reason) {
                                                            $scope.$apply(function () {
                                                                $scope.message.error = reason;
                                                                $scope.valid.commit = true;
                                                            })
                                                        }
                                                    });
                                                }
                                                catch (ex) {
                                                    console.log(ex);
                                                    $scope.message.error = ex.message;
                                                }
                                            }
                                            else {
                                                $scope.divMessage.error = wechatInfo.message;
                                            }
                                        });
                                }
                            }
                        }
                        else {
                            $scope.message.error = rechargeInfo.message;
                        }
                    });

            }
        }
        //返回
        $scope.goBack = function () {
            if ($scope.divShow.div2) {
                $scope.divShow = { "div1": true, "div2": false };
            }
            else {
                $ionicViewSwitcher.nextDirection("back");
                if ($ionicHistory.backView()) {
                    $ionicHistory.goBack();
                } else {
                    $state.go('tab.mine');
                }
            }
            $scope.message = { "error": "" };
        }

        $scope.init();
    })

    .controller('scoreExchangeControl', function ($scope, $rootScope, $http, $ionicHistory, UserSecurity) {
        $scope.init = function () {
            $scope.exchangeInfo = { 'scoreNum': null, 'keyNum': null, 'rate': null, 'exchangeNum': null };
            $scope.exchangeList = null;
            $scope.input = { 'exchangeNum': "" };
            $scope.message = { 'error': "" };
            $scope.firstExchangeGeted = true;
            $scope.getExchangeInfo();
        }
        $scope.getExchangeInfo = function () {
            $http({ method: "POST", url: $rootScope._serverSvc + "getMemberScoreExchangeInfo", data: { 'mid': UserSecurity.mid, 'token': UserSecurity.token } })
                .success(function (sdata) {
                    var scoreInfo = JSON.parse(sdata.d);
                    if (scoreInfo.status == "Done") {
                        var scoreData = JSON.parse(scoreInfo.value);
                        $rootScope._memberInfo.scoreNum = scoreData.score;
                        $rootScope._memberInfo.keyNum = scoreData.targetNum;
                        $scope.exchangeInfo.scoreNum = scoreData.score;
                        $scope.exchangeInfo.keyNum = scoreData.targetNum;
                        $scope.exchangeInfo.rate = scoreData.exchangeRate;
                        $scope.exchangeInfo.exchangeNum = scoreData.exchangeNum;
                        $scope.getScoreExchangeListInit();
                    }
                    else {
                        $scope.message.error = scoreInfo.message;
                    }
                });
        }
        $scope.checkNumInput = function () {
            if ($scope.input.exchangeNum != null && !isNaN($scope.input.exchangeNum)) {
                var exchangeNum = parseInt($scope.input.exchangeNum);
                if (exchangeNum > $scope.exchangeInfo.exchangeNum) {
                    exchangeNum = $scope.exchangeInfo.exchangeNum;
                }
                $scope.input.exchangeNum = Number(exchangeNum);
            }
        }
        $scope.exchangeToKey = function () {
            if (isNaN($scope.input.exchangeNum) && $scope.input.exchangeNum > 0) {
                $scope.message.error = "兑换数量输入无效";
                return;
            }
            $http({ method: "POST", url: $rootScope._serverSvc + "ExchangeScoreToBoxkey", data: { 'mid': UserSecurity.mid, 'token': UserSecurity.token, 'num': $scope.input.exchangeNum } })
                .success(function (sdata) {
                    var exchangeInfo = JSON.parse(sdata.d);
                    if (exchangeInfo.status == "Done") {
                        var exchangeData = JSON.parse(exchangeInfo.value);
                        $rootScope._memberInfo.scoreNum = exchangeData.score;
                        $rootScope._memberInfo.keyNum = exchangeData.targetNum;
                        $scope.exchangeInfo.scoreNum = exchangeData.score;
                        $scope.exchangeInfo.keyNum = exchangeData.targetNum;
                        $scope.exchangeInfo.rate = exchangeData.exchangeRate;
                        $scope.exchangeInfo.exchangeNum = exchangeData.exchangeNum;
                        $scope.message.error = "兑换成功,消费积分" + exchangeData.scoreCost + "个";
                        $scope.input.exchangeNum = null;
                        $scope.getScoreExchangeListInit();
                    }
                    else {
                        $scope.message.error = exchangeInfo.message;
                    }
                });
        }
        $scope.getScoreExchangeListInit = function () {
            $http({ method: "POST", url: $rootScope._serverSvc + "getScoreExchangeRecord", data: { 'mid': UserSecurity.mid, 'token': UserSecurity.token, 'maxID': "" } })
                .success(function (sdata) {
                    var exchangeInfo = JSON.parse(sdata.d);
                    if (exchangeInfo.status == "Done") {
                        if (exchangeInfo.value != "{}") {
                            $scope.exchangeList = JSON.parse(exchangeInfo.value);
                            $scope.firstExchangeGeted = false;
                        }
                        else {
                            $scope.firstExchangeGeted = true;
                        }
                    }
                    else {
                        $scope.message.error = exchangeInfo.message;
                    }
                })
        }
        $scope.getScoreExchangeListMore = function () {
            if (!$scope.firstExchangeGeted && $scope.exchangeList.length > 0) {
                $http({ method: "POST", url: $rootScope._serverSvc + "getScoreExchangeRecord", data: { 'mid': UserSecurity.mid, 'token': UserSecurity.token, 'maxID': $scope.exchangeList[$scope.exchangeList.length - 1].id } })
                    .success(function (sdata) {
                        var exchangeInfo = JSON.parse(sdata.d);
                        if (exchangeInfo.status == "Done") {
                            if (exchangeInfo.value == "{}") {
                                $scope.firstExchangeGeted = true;
                            }
                            else {
                                var exchangeData = JSON.parse(exchangeInfo.value);
                                for (var i = 0; i <= exchangeData.length - 1; i++) {
                                    $scope.exchangeList.push(exchangeData[i]);
                                }
                            }
                        }
                        else {
                            $scope.message.error = exchangeInfo.message;
                        }
                    })
                    .finally(function () {
                        $scope.$broadcast("scroll.infiniteScrollComplete");
                    });
            }
        }
        $scope.moreDataCanBeLoaded = function () {
            return !$scope.firstExchangeGeted;
        }
        $scope.init();
    })

    .controller('settingsControl', function ($scope, $state, $ionicViewSwitcher) {
        $scope.goBack = function () {
            $ionicViewSwitcher.nextDirection("back");
            $state.go("tab.mine");
        }
    })

    .controller('myMessageControl', function ($scope, $rootScope, $http, $interval, $state, $ionicHistory, $ionicViewSwitcher, $ionicScrollDelegate, UserSecurity) {
        $scope.$on('$ionicView.enter', function () {
            $scope.keepUpdate = true;
            if ($scope.messageInited) {
                $scope.getMessageUpdate();
            }
        });
        $scope.$on('$ionicView.leave', function () {
            $scope.keepUpdate = false;
        });
        $scope.init = function () {
            $scope.messageList = [];//消息列表
            $scope.currentMessage = {};//当前消息
            $scope.keepUpdate = true;//是否轮询最新消息
            $scope.firstMessageGeted = false;
            $scope.messageInited = false;
            $scope.divShow = { 'div1': true, 'div2': false };
            $scope.message = { 'error': '' };
            $scope.getMessageInit();
        }
        //获取初始消息列表
        $scope.getMessageInit = function () {
            $http({ method: "POST", url: $rootScope._serverSvc + "getMemberMessageListHistory", data: { 'mid': UserSecurity.mid, 'token': UserSecurity.token, 'minMessageID': 0 } })
                .success(function (sdata) {
                    var messageData = JSON.parse(sdata.d);
                    if (messageData.status == "Done") {
                        if (messageData.value == "{}") {
                            $scope.firstMessageGeted = true;
                        }
                        else {
                            $scope.messageList = JSON.parse(messageData.value);
                        }
                        $scope.messageInited = true;
                        $interval($scope.getMessageUpdate, 120000);
                    }
                    else {
                        $scope.message.error = messageData.message;
                    }
                });
        }
        //获取更新消息列表
        $scope.getMessageUpdate = function () {
            if ($scope.keepUpdate) {
                $http({ method: "POST", url: $rootScope._serverSvc + "getMemberMessageListLatest", data: { 'mid': UserSecurity.mid, 'token': UserSecurity.token, 'maxMessageID': (typeof ($scope.messageList[0]) != "undefined" ? $scope.messageList[0].id : 0) } })
                .success(function (sdata) {
                    var messageData = JSON.parse(sdata.d);
                    if (messageData.status == "Done") {
                        var newMessage = JSON.parse(messageData.value);
                        if (newMessage.length > 0) {
                            var i;
                            for (i = newMessage.length - 1; i >= 0; i--) {
                                $scope.messageList.unshift(newMessage[i]);
                            }
                        }
                    }
                    else {
                        $scope.message.error = messageData.message;
                    }
                })
            }
        }
        //获取历史消息列表
        $scope.getMessageHistory = function () {
            if (!$scope.firstMessageGeted && $scope.messageList.length > 0) {
                $http({ method: "POST", url: $rootScope._serverSvc + "getMemberMessageListHistory", data: { 'mid': UserSecurity.mid, 'token': UserSecurity.token, 'minMessageID': $scope.messageList[$scope.messageList.length - 1].id } })
                    .success(function (sdata) {
                        var messageData = JSON.parse(sdata.d);
                        if (messageData.status == "Done") {
                            var historyMessage = JSON.parse(messageData.value);
                            if (historyMessage.length > 0) {
                                var i;
                                for (i = 0; i <= historyMessage.length - 1; i++) {
                                    $scope.messageList.push(historyMessage[i]);
                                }
                            }
                            else {
                                $scope.firstMessageGeted = true;
                            }
                        }
                    })
                    .finally(function () {
                        $scope.$broadcast("scroll.infiniteScrollComplete");
                    });
            }
        }
        $scope.moreDataCanBeLoaded = function () {
            return !$scope.firstMessageGeted;
        }
        $scope.showMessageDetail = function (message) {
            $scope.currentMessage = message;
            $scope.divShow = { 'div1': false, 'div2': true };
            $ionicScrollDelegate.scrollTop(false);
            if (message.status == 1) {
                $http({ method: "POST", url: $rootScope._serverSvc + "setMemberMessageReaded", data: { 'messageID': message.id } })
                    .success(function (sdata) {
                        $scope.currentMessage.status = 2;
                    })
            }
        }
        $scope.goBack = function () {
            if ($scope.divShow.div1) {
                $scope.keepUpdate = false;
                $ionicViewSwitcher.nextDirection("back");
                if ($ionicHistory.backView()) {
                    $ionicHistory.goBack();
                } else {
                    $state.go('tab.mine');
                }
            }
            else {
                $scope.divShow = { 'div1': true, 'div2': false };
                $scope.message = { 'error': '' };
                $scope.currentMessage = {};
            }
        }
        $scope.init();
    })

    .controller('myDrawControl', function ($scope, $rootScope, $http, $state, $window, $ionicHistory, $ionicViewSwitcher, $ionicScrollDelegate, UserLocation, UserSecurity, MD5Service, QRCode) {
        $scope.init = function () {
            $scope.prizeList = [];
            $scope.currentPrize = {};
            $scope.firstPrizeGeted = false;
            $scope.divShow = { 'div1': true, 'div2': false, 'div3': false, 'div4': false, 'div5': false, 'div6': false };
            $scope.message = { 'div1': "", 'div2': "", 'div4': "", 'div6': "" };
            $scope.input = { 'payPass': "" };
            $scope.size = $window.screen.availWidth * 0.9;
            $scope.getShareData();
        }
        $scope.getPrizeInit = function () {
            $http({ method: "POST", url: $rootScope._serverSvc + "getMemberPrizeList", data: { 'mid': UserSecurity.mid, 'token': UserSecurity.token, 'earliestTime': "" } })
                .success(function (sdata) {
                    var prizeData = JSON.parse(sdata.d);
                    if (prizeData.status == "Done") {
                        if (prizeData.value == "{}") {
                            $scope.firstPrizeGeted = true;
                            $scope.message.div1 = '您目前没有可领取的奖品';
                        }
                        else {
                            $scope.prizeList = JSON.parse(prizeData.value);
                        }
                    }
                    else {
                        $scope.message.div1 = prizeData.message;
                    }
                })
        }
        $scope.getPrizeHistory = function () {
            if (!$scope.firstPrizeGeted && $scope.prizeList.length > 0) {
                $http({ method: "POST", url: $rootScope._serverSvc + "getMemberPrizeList", data: { 'mid': UserSecurity.mid, 'token': UserSecurity.token, 'earliestTime': $scope.prizeList[$scope.prizeList.length - 1].openTime } })
                    .success(function (sdata) {
                        var prizeData = JSON.parse(sdata.d);
                        if (prizeData.status == "Done") {
                            var historyPrize = JSON.parse(prizeData.value);
                            if (historyPrize.length > 0) {
                                var i;
                                for (i = 0; i <= historyPrize.length - 1; i++) {
                                    $scope.prizeList.push(historyPrize[i]);
                                }
                            }
                            else {
                                $scope.firstPrizeGeted = true;
                            }
                        }
                    })
                    .finally(function () {
                        $scope.$broadcast("scroll.infiniteScrollComplete");
                    });
            }
        }
        $scope.goPrizeDetail = function (bid, did) {
            var i;
            for (i = 0; i <= $scope.prizeList.length - 1; i++) {
                if ($scope.prizeList[i].batchId == bid && $scope.prizeList[i].drawNo == did) {
                    $scope.currentPrize = $scope.prizeList[i];
                    $scope.divShow = { 'div1': false, 'div2': true, 'div3': false, 'div4': false, 'div5': false, 'div6': false };
                    $ionicScrollDelegate.scrollTop(false);
                    break;
                }
            }
        }
        $scope.goBarcode = function () {
            $scope.divShow = { 'div1': false, 'div2': false, 'div3': false, 'div4': true, 'div5': false, 'div6': false };
        }
        $scope.checkPayPass = function () {
            $scope.message.div4 = "";
            var payPass = String($scope.input.payPass);
            if (payPass.length == 6) {
                $http({ method: "POST", url: $rootScope._serverSvc + "checkMemberPayPass", data: { 'mid': UserSecurity.mid, 'token': UserSecurity.token, 'payPass': MD5Service.hex_md5(payPass) } })
                .success(function (sdata) {
                    var prizeData = JSON.parse(sdata.d);
                    if (prizeData.status == "Done") {
                        //生成二维码
                        document.getElementById("qrcode").innerHTML = "";
                        var qrcode = new QRCode(document.getElementById("qrcode"), { width: $scope.size, height: $scope.size });
                        qrcode.makeCode($scope.currentPrize.exchangeCode);
                        $scope.addMemberEvent(6);
                        $scope.divShow = { 'div1': false, 'div2': false, 'div3': false, 'div4': false, 'div5': true, 'div6': false };
                    }
                    else {
                        $scope.message.div4 = prizeData.message;
                    }
                })
            }
        }
        $scope.goExchange = function () {
            $http({ method: "POST", url: $rootScope._serverSvc + "exchangeSoftPrize", data: { 'mid': UserSecurity.mid, 'token': UserSecurity.token, 'bid': $scope.currentPrize.batchId, 'did': $scope.currentPrize.drawNo } })
                .success(function (sdata) {
                    var prizeData = JSON.parse(sdata.d);
                    if (prizeData.status == "Done") {
                        $scope.addMemberEvent(5);
                        $scope.divShow = { 'div1': false, 'div2': false, 'div3': true, 'div4': false, 'div5': false, 'div6': false };
                    }
                    else {
                        $scope.message.div2 = prizeData.message;
                    }
                })
        }
        $scope.moreDataCanBeLoaded = function () {
            return !$scope.firstPrizeGeted;
        }
        $scope.goPrizeExchanged = function () {
            $state.go("myDrawExchanged");
        }
        $scope.goPrizeTimeover = function () {
            $state.go("myDrawTimeover");
        }
        $scope.getShareData = function () {
            $http({ method: "POST", url: $rootScope._serverSvc + "getMemberPrizeShare", data: {} })
                .success(function (sdata) {
                    var serverData = JSON.parse(sdata.d);
                    if (serverData.status == "Done") {
                        $scope.shareData = JSON.parse(serverData.value);
                    }
                    else {
                        $scope.message.div1 = serverData.message;
                    }
                    $scope.getPrizeInit();
                });
        }
        $scope.addMemberEvent = function (type) {
            $http({ method: "POST", url: $rootScope._serverSvc + "addMemberEvent", data: { 'mid': UserSecurity.mid, 'token': UserSecurity.token, 'type': type, 'locationX': UserLocation.realX, 'locationY': UserLocation.realY, 'uuid': $rootScope._uuid, 'remark': $scope.currentPrize.drawNo } }).success(function (sdata) { });
        }
        $scope.share0 = function () {
            var regExp1 = new RegExp("@prizeName@", "g");
            var regExp2 = new RegExp("@showValue@", "g");
            var title = (($scope.shareData.title).replace(regExp1, $scope.currentPrize.bonusName)).replace(regExp2, $scope.currentPrize.showValue);
            var description = (($scope.shareData.description).replace(regExp1, $scope.currentPrize.bonusName)).replace(regExp2, $scope.currentPrize.showValue);
            Wechat.isInstalled(function (installed) {
                if (installed) {
                    Wechat.share({
                        message: {
                            title: title,
                            description: description,
                            thumb: $rootScope._serverUrl + $scope.shareData.imageUrl,
                            media: {
                                type: Wechat.Type.WEBPAGE,
                                webpageUrl: $scope.shareData.pageUrl
                            }
                        },
                        scene: Wechat.Scene.SESSION
                    }, function () {
                        $http({ method: "POST", url: $rootScope._serverSvc + "addMemberShareRecord", data: { 'mid': UserSecurity.mid, 'token': UserSecurity.token, 'type': $scope.shareData.stageName, 'scene': 0 } })
                            .success(function (sdata) {
                                var serverData = JSON.parse(sdata.d);
                                if (serverData.status == "Done") {
                                    $scope.message.div6 = "分享成功";
                                }
                                else {
                                    $scope.message.div6 = serverData.message;
                                }
                            });
                    }, function (reason) {
                        $scope.$apply(function () {
                            $scope.message.div6 = reason;
                        })
                    });
                }
                else {
                    $scope.message.div6 = "您的手机上未安装微信";
                }
            }, function (reason) {
                $scope.$apply(function () {
                    $scope.message.div6 = reason;
                });
            });
        }
        $scope.share1 = function () {
            var regExp1 = new RegExp("@prizeName@", "g");
            var regExp2 = new RegExp("@showValue@", "g");
            var title = (($scope.shareData.title).replace(regExp1, $scope.currentPrize.bonusName)).replace(regExp2, $scope.currentPrize.showValue);
            var description = (($scope.shareData.description).replace(regExp1, $scope.currentPrize.bonusName)).replace(regExp2, $scope.currentPrize.showValue);
            Wechat.isInstalled(function (installed) {
                if (installed) {
                    Wechat.share({
                        message: {
                            title: title,
                            description: description,
                            thumb: $rootScope._serverUrl + $scope.shareData.imageUrl,
                            media: {
                                type: Wechat.Type.WEBPAGE,
                                webpageUrl: $scope.shareData.pageUrl
                            }
                        },
                        scene: Wechat.Scene.TIMELINE
                    }, function () {
                        $http({ method: "POST", url: $rootScope._serverSvc + "addMemberShareRecord", data: { 'mid': UserSecurity.mid, 'token': UserSecurity.token, 'type': $scope.shareData.stageName, 'scene': 1 } })
                            .success(function (sdata) {
                                console.log(sdata);
                                var serverData = JSON.parse(sdata.d);
                                if (serverData.status == "Done") {
                                    $scope.message.div6 = "分享成功";
                                }
                                else {
                                    $scope.message.div6 = serverData.message;
                                }
                            });
                    }, function (reason) {
                        $scope.$apply(function () {
                            $scope.message.div6 = reason;
                        })
                    });
                }
                else {
                    $scope.message.div6 = "您的手机上未安装微信";
                }
            }, function (reason) {
                $scope.$apply(function () {
                    $scope.message.div6 = reason;
                });
            });
        }
        $scope.goWechatShare = function () {
            $scope.divShow = { 'div1': false, 'div2': false, 'div3': false, 'div4': false, 'div5': false, 'div6': true };
        }
        $scope.goBack = function () {
            if ($scope.divShow.div1) {
                $ionicViewSwitcher.nextDirection("back");
                if ($ionicHistory.backView()) {
                    $ionicHistory.goBack();
                } else {
                    $state.go('tab.mine');
                }
            }
            else {
                if ($scope.divShow.div2) {
                    $scope.divShow = { 'div1': true, 'div2': false, 'div3': false, 'div4': false, 'div5': false, 'div6': false };
                    $scope.message = { 'div1': "", 'div2': "", 'div4': "", 'div6': "" };
                    $scope.currentPrize = {};
                }
                else {
                    if ($scope.divShow.div3) {
                        $scope.prizeList = [];
                        $scope.currentPrize = {};
                        $scope.firstPrizeGeted = false;
                        $scope.divShow = { 'div1': true, 'div2': false, 'div3': false, 'div4': false, 'div5': false, 'div6': false };
                        $scope.message = { 'div1': "", 'div2': "", 'div4': "", 'div6': "" };
                        $scope.input = { 'payPass': "" };
                        $scope.getPrizeInit();
                    }
                    else {
                        if ($scope.divShow.div4 || $scope.divShow.div5) {
                            $scope.divShow = { 'div1': false, 'div2': true, 'div3': false, 'div4': false, 'div5': false, 'div6': false };
                            $scope.input.payPass = "";
                        }
                        else {
                            if ($scope.divShow.div6) {
                                $scope.divShow = { 'div1': false, 'div2': true, 'div3': false, 'div4': false, 'div5': false, 'div6': false };
                                $scope.message.div6 = "";
                            }
                        }
                    }
                }
            }
        }
        $scope.init();
    })

    .controller('myDrawExchangedControl', function ($scope, $rootScope, $http, $state, $ionicViewSwitcher, $ionicScrollDelegate, UserSecurity) {
        $scope.init = function () {
            $scope.prizeList = [];
            $scope.currentPrize = {};
            $scope.shareData = null;
            $scope.firstPrizeGeted = false;
            $scope.divShow = { 'div1': true, 'div2': false, 'div3': false };
            $scope.message = { 'div1': "", 'div2': "", 'div3': "" };
            $scope.getShareData();
        }
        $scope.getPrizeInit = function () {
            $http({ method: "POST", url: $rootScope._serverSvc + "getMemberPrizeExchanged", data: { 'mid': UserSecurity.mid, 'token': UserSecurity.token, 'earliestTime': "" } })
                .success(function (sdata) {
                    var prizeData = JSON.parse(sdata.d);
                    if (prizeData.status == "Done") {
                        if (prizeData.value == "{}") {
                            $scope.firstPrizeGeted = true;
                            $scope.message.div1 = '您目前没有已领取的奖品';
                        }
                        else {
                            $scope.prizeList = JSON.parse(prizeData.value);
                        }
                    }
                    else {
                        $scope.message.div1 = prizeData.message;
                    }
                })
        }
        $scope.getPrizeHistory = function () {
            if (!$scope.firstPrizeGeted && $scope.prizeList.length > 0) {
                $http({ method: "POST", url: $rootScope._serverSvc + "getMemberPrizeExchanged", data: { 'mid': UserSecurity.mid, 'token': UserSecurity.token, 'earliestTime': $scope.prizeList[$scope.prizeList.length - 1].useTime } })
                    .success(function (sdata) {
                        var prizeData = JSON.parse(sdata.d);
                        if (prizeData.status == "Done") {
                            var historyPrize = JSON.parse(prizeData.value);
                            if (historyPrize.length > 0) {
                                var i;
                                for (i = 0; i <= historyPrize.length - 1; i++) {
                                    $scope.prizeList.push(historyPrize[i]);
                                }
                            }
                            else {
                                $scope.firstPrizeGeted = true;
                            }
                        }
                    })
                    .finally(function () {
                        $scope.$broadcast("scroll.infiniteScrollComplete");
                    });
            }
        }
        $scope.getShareData = function () {
            $http({ method: "POST", url: $rootScope._serverSvc + "getMemberPrizeShare", data: {} })
                .success(function (sdata) {
                    var serverData = JSON.parse(sdata.d);
                    if (serverData.status == "Done") {
                        $scope.shareData = JSON.parse(serverData.value);
                    }
                    else {
                        $scope.message.div1 = serverData.message;
                    }
                    $scope.getPrizeInit();
                });
        }
        $scope.share0 = function () {
            var regExp1 = new RegExp("@prizeName@", "g");
            var regExp2 = new RegExp("@showValue@", "g");
            var title = (($scope.shareData.title).replace(regExp1, $scope.currentPrize.bonusName)).replace(regExp2, $scope.currentPrize.showValue);
            var description = (($scope.shareData.description).replace(regExp1, $scope.currentPrize.bonusName)).replace(regExp2, $scope.currentPrize.showValue);
            Wechat.isInstalled(function (installed) {
                if (installed) {
                    Wechat.share({
                        message: {
                            title: title,
                            description: description,
                            thumb: $rootScope._serverUrl + $scope.shareData.imageUrl,
                            media: {
                                type: Wechat.Type.WEBPAGE,
                                webpageUrl: $scope.shareData.pageUrl
                            }
                        },
                        scene: Wechat.Scene.SESSION
                    }, function () {
                        $http({ method: "POST", url: $rootScope._serverSvc + "addMemberShareRecord", data: { 'mid': UserSecurity.mid, 'token': UserSecurity.token, 'type': $scope.shareData.stageName, 'scene': 0 } })
                            .success(function (sdata) {
                                var serverData = JSON.parse(sdata.d);
                                if (serverData.status == "Done") {
                                    $scope.message.div3 = "分享成功";
                                }
                                else {
                                    $scope.message.div3 = serverData.message;
                                }
                            });
                    }, function (reason) {
                        $scope.$apply(function () {
                            $scope.message.div3 = reason;
                        })
                    });
                }
                else {
                    $scope.message.div3 = "您的手机上未安装微信";
                }
            }, function (reason) {
                $scope.$apply(function () {
                    $scope.message.div3 = reason;
                });
            });
        }
        $scope.share1 = function () {
            var regExp1 = new RegExp("@prizeName@", "g");
            var regExp2 = new RegExp("@showValue@", "g");
            var title = (($scope.shareData.title).replace(regExp1, $scope.currentPrize.bonusName)).replace(regExp2, $scope.currentPrize.showValue);
            var description = (($scope.shareData.description).replace(regExp1, $scope.currentPrize.bonusName)).replace(regExp2, $scope.currentPrize.showValue);
            Wechat.isInstalled(function (installed) {
                if (installed) {
                    Wechat.share({
                        message: {
                            title: title,
                            description: description,
                            thumb: $rootScope._serverUrl + $scope.shareData.imageUrl,
                            media: {
                                type: Wechat.Type.WEBPAGE,
                                webpageUrl: $scope.shareData.pageUrl
                            }
                        },
                        scene: Wechat.Scene.TIMELINE
                    }, function () {
                        $http({ method: "POST", url: $rootScope._serverSvc + "addMemberShareRecord", data: { 'mid': UserSecurity.mid, 'token': UserSecurity.token, 'type': $scope.shareData.stageName, 'scene': 1 } })
                            .success(function (sdata) {
                                console.log(sdata);
                                var serverData = JSON.parse(sdata.d);
                                if (serverData.status == "Done") {
                                    $scope.message.div3 = "分享成功";
                                }
                                else {
                                    $scope.message.div3 = serverData.message;
                                }
                            });
                    }, function (reason) {
                        $scope.$apply(function () {
                            $scope.message.div3 = reason;
                        })
                    });
                }
                else {
                    $scope.message.div3 = "您的手机上未安装微信";
                }
            }, function (reason) {
                $scope.$apply(function () {
                    $scope.message.div3 = reason;
                });
            });
        }
        $scope.goPrizeDetail = function (bid, did) {
            var i;
            for (i = 0; i <= $scope.prizeList.length - 1; i++) {
                if ($scope.prizeList[i].batchId == bid && $scope.prizeList[i].drawNo == did) {
                    $scope.currentPrize = $scope.prizeList[i];
                    $scope.divShow = { 'div1': false, 'div2': true, 'div3': false };
                    $ionicScrollDelegate.scrollTop(false);
                    break;
                }
            }
        }
        $scope.goWechatShare = function () {
            $scope.divShow = { 'div1': false, 'div2': false, 'div3': true };
        }
        $scope.goBack = function () {
            if ($scope.divShow.div1) {
                $ionicViewSwitcher.nextDirection("back");
                $state.go('myDraw');
            }
            else {
                if ($scope.divShow.div3) {
                    $scope.divShow = { 'div1': false, 'div2': true, 'div3': false };
                }
                else {
                    $scope.divShow = { 'div1': true, 'div2': false, 'div3': false };
                    $scope.message = { 'div1': "", 'div2': "", 'div3': "" };
                    $scope.currentPrize = {};
                }
            }
        }
        $scope.moreDataCanBeLoaded = function () {
            return !$scope.firstPrizeGeted;
        }
        $scope.init();
    })

    .controller('myDrawTimeoverControl', function ($scope, $rootScope, $http, $state, $ionicViewSwitcher, $ionicScrollDelegate, UserSecurity) {
        $scope.init = function () {
            $scope.prizeList = [];
            $scope.currentPrize = {};
            $scope.shareData = null;
            $scope.firstPrizeGeted = false;
            $scope.divShow = { 'div1': true, 'div2': false, 'div3': false };
            $scope.message = { 'div1': "", 'div2': "", 'div3': "" };
            $scope.getShareData();
        }
        $scope.getPrizeInit = function () {
            $http({ method: "POST", url: $rootScope._serverSvc + "getMemberPrizeTimeover", data: { 'mid': UserSecurity.mid, 'token': UserSecurity.token, 'earliestTime': "" } })
                .success(function (sdata) {
                    var prizeData = JSON.parse(sdata.d);
                    if (prizeData.status == "Done") {
                        if (prizeData.value == "{}") {
                            $scope.firstPrizeGeted = true;
                            $scope.message.div1 = '您目前没有已过期的奖品';
                        }
                        else {
                            $scope.prizeList = JSON.parse(prizeData.value);
                        }
                    }
                    else {
                        $scope.message.div1 = prizeData.message;
                    }
                })
        }
        $scope.getPrizeHistory = function () {
            if (!$scope.firstPrizeGeted && $scope.prizeList.length > 0) {
                $http({ method: "POST", url: $rootScope._serverSvc + "getMemberPrizeTimeover", data: { 'mid': UserSecurity.mid, 'token': UserSecurity.token, 'earliestTime': $scope.prizeList[$scope.prizeList.length - 1].openTime } })
                    .success(function (sdata) {
                        var prizeData = JSON.parse(sdata.d);
                        if (prizeData.status == "Done") {
                            var historyPrize = JSON.parse(prizeData.value);
                            if (historyPrize.length > 0) {
                                var i;
                                for (i = 0; i <= historyPrize.length - 1; i++) {
                                    $scope.prizeList.push(historyPrize[i]);
                                }
                            }
                            else {
                                $scope.firstPrizeGeted = true;
                            }
                        }
                    })
                    .finally(function () {
                        $scope.$broadcast("scroll.infiniteScrollComplete");
                    });
            }
        }
        $scope.getShareData = function () {
            $http({ method: "POST", url: $rootScope._serverSvc + "getMemberPrizeShare", data: {} })
                .success(function (sdata) {
                    var serverData = JSON.parse(sdata.d);
                    if (serverData.status == "Done") {
                        $scope.shareData = JSON.parse(serverData.value);
                    }
                    else {
                        $scope.message.div1 = serverData.message;
                    }
                    $scope.getPrizeInit();
                });
        }
        $scope.share0 = function () {
            var regExp1 = new RegExp("@prizeName@", "g");
            var regExp2 = new RegExp("@showValue@", "g");
            var title = (($scope.shareData.title).replace(regExp1, $scope.currentPrize.bonusName)).replace(regExp2, $scope.currentPrize.showValue);
            var description = (($scope.shareData.description).replace(regExp1, $scope.currentPrize.bonusName)).replace(regExp2, $scope.currentPrize.showValue);
            Wechat.isInstalled(function (installed) {
                if (installed) {
                    Wechat.share({
                        message: {
                            title: title,
                            description: description,
                            thumb: $rootScope._serverUrl + $scope.shareData.imageUrl,
                            media: {
                                type: Wechat.Type.WEBPAGE,
                                webpageUrl: $scope.shareData.pageUrl
                            }
                        },
                        scene: Wechat.Scene.SESSION
                    }, function () {
                        $http({ method: "POST", url: $rootScope._serverSvc + "addMemberShareRecord", data: { 'mid': UserSecurity.mid, 'token': UserSecurity.token, 'type': $scope.shareData.stageName, 'scene': 0 } })
                            .success(function (sdata) {
                                var serverData = JSON.parse(sdata.d);
                                if (serverData.status == "Done") {
                                    $scope.message.div3 = "分享成功";
                                }
                                else {
                                    $scope.message.div3 = serverData.message;
                                }
                            });
                    }, function (reason) {
                        $scope.$apply(function () {
                            $scope.message.div3 = reason;
                        })
                    });
                }
                else {
                    $scope.message.div3 = "您的手机上未安装微信";
                }
            }, function (reason) {
                $scope.$apply(function () {
                    $scope.message.div3 = reason;
                });
            });
        }
        $scope.share1 = function () {
            var regExp1 = new RegExp("@prizeName@", "g");
            var regExp2 = new RegExp("@showValue@", "g");
            var title = (($scope.shareData.title).replace(regExp1, $scope.currentPrize.bonusName)).replace(regExp2, $scope.currentPrize.showValue);
            var description = (($scope.shareData.description).replace(regExp1, $scope.currentPrize.bonusName)).replace(regExp2, $scope.currentPrize.showValue);
            Wechat.isInstalled(function (installed) {
                if (installed) {
                    Wechat.share({
                        message: {
                            title: title,
                            description: description,
                            thumb: $rootScope._serverUrl + $scope.shareData.imageUrl,
                            media: {
                                type: Wechat.Type.WEBPAGE,
                                webpageUrl: $scope.shareData.pageUrl
                            }
                        },
                        scene: Wechat.Scene.TIMELINE
                    }, function () {
                        $http({ method: "POST", url: $rootScope._serverSvc + "addMemberShareRecord", data: { 'mid': UserSecurity.mid, 'token': UserSecurity.token, 'type': $scope.shareData.stageName, 'scene': 1 } })
                            .success(function (sdata) {
                                console.log(sdata);
                                var serverData = JSON.parse(sdata.d);
                                if (serverData.status == "Done") {
                                    $scope.message.div3 = "分享成功";
                                }
                                else {
                                    $scope.message.div3 = serverData.message;
                                }
                            });
                    }, function (reason) {
                        $scope.$apply(function () {
                            $scope.message.div3 = reason;
                        })
                    });
                }
                else {
                    $scope.message.div3 = "您的手机上未安装微信";
                }
            }, function (reason) {
                $scope.$apply(function () {
                    $scope.message.div3 = reason;
                });
            });
        }
        $scope.goPrizeDetail = function (bid, did) {
            var i;
            for (i = 0; i <= $scope.prizeList.length - 1; i++) {
                if ($scope.prizeList[i].batchId == bid && $scope.prizeList[i].drawNo == did) {
                    $scope.currentPrize = $scope.prizeList[i];
                    $scope.divShow = { 'div1': false, 'div2': true, 'div3': false };
                    $ionicScrollDelegate.scrollTop(false);
                    break;
                }
            }
        }
        $scope.goWechatShare = function () {
            $scope.divShow = { 'div1': false, 'div2': false, 'div3': true };
        }
        $scope.goBack = function () {
            if ($scope.divShow.div1) {
                $ionicViewSwitcher.nextDirection("back");
                $state.go('myDraw');
            }
            else {
                if ($scope.divShow.div3) {
                    $scope.divShow = { 'div1': false, 'div2': true, 'div3': false };
                }
                else {
                    $scope.divShow = { 'div1': true, 'div2': false, 'div3': false };
                    $scope.message = { 'div1': "", 'div2': "", 'div3': "" };
                    $scope.currentPrize = {};
                }
            }
        }
        $scope.moreDataCanBeLoaded = function () {
            return !$scope.firstPrizeGeted;
        }
        $scope.init();
    })

    .controller('myDealControl', function ($scope, $rootScope, $http, $state, $ionicHistory, $ionicViewSwitcher, $ionicScrollDelegate, UserSecurity) {
        $scope.init = function () {
            $scope.tradingList = [];
            $scope.evaluateTypes = [];
            $scope.currentTrading = {};
            $scope.firstTradingGeted = false;
            $scope.divShow = { 'div1': true, 'div2': false, 'div3': false, 'div4': false };
            $scope.message = { 'div1': "", 'div2': "", 'div3': "" };
            $scope.input = { 'evaluateContent': "", 'evaluateType': 0 };
            $scope.starSrc = { 'star1': "img/zero.png", 'star2': "img/zero.png", 'star3': "img/zero.png", 'star4': "img/zero.png", 'star5': "img/zero.png" };
            $scope.evaluateDescription = "";
            $scope.getTradingInit();
        }
        $scope.getTradingInit = function () {
            $http({ method: "POST", url: $rootScope._serverSvc + "getMemberTradingList", data: { 'mid': UserSecurity.mid, 'token': UserSecurity.token, 'earliestTime': "" } })
                .success(function (sdata) {
                    var tradingData = JSON.parse(sdata.d);
                    if (tradingData.status == "Done") {
                        if (tradingData.value == "{}") {
                            $scope.firstTradingGeted = true;
                        }
                        else {
                            $scope.tradingList = JSON.parse(tradingData.value);
                        }
                    }
                    else {
                        $scope.message.div1 = tradingData.message;
                    }
                })
        }
        $scope.getTradingHistory = function () {
            if (!$scope.firstTradingGeted && $scope.tradingList.length > 0) {
                $http({ method: "POST", url: $rootScope._serverSvc + "getMemberTradingList", data: { 'mid': UserSecurity.mid, 'token': UserSecurity.token, 'earliestTime': $scope.tradingList[$scope.tradingList.length - 1].createTime } })
                    .success(function (sdata) {
                        var tradingData = JSON.parse(sdata.d);
                        if (tradingData.status == "Done") {
                            var historyTrading = JSON.parse(tradingData.value);
                            if (historyTrading.length > 0) {
                                var i;
                                for (i = 0; i <= historyTrading.length - 1; i++) {
                                    $scope.tradingList.push(historyTrading[i]);
                                }
                            }
                            else {
                                $scope.firstTradingGeted = true;
                            }
                        }
                    })
                    .finally(function () {
                        $scope.$broadcast("scroll.infiniteScrollComplete");
                    });
            }
        }
        $scope.showTradingDetail = function (tradingNo) {
            $http({ method: "POST", url: $rootScope._serverSvc + "getMemberTradingDetail", data: { 'mid': UserSecurity.mid, 'token': UserSecurity.token, 'tn': tradingNo } })
                .success(function (sdata) {
                    var tradingData = JSON.parse(sdata.d);
                    if (tradingData.status == "Done") {
                        $scope.currentTrading = JSON.parse(tradingData.value);
                    }
                    else {
                        $scope.message.div2 = tradingData.message;
                    }
                    $scope.divShow = { 'div1': false, 'div2': true, 'div3': false, 'div4': false };
                    $ionicScrollDelegate.scrollTop(false);
                })
        }
        $scope.goPayoff = function () {
            $rootScope._dealParam = $scope.currentTrading.tradingNo;
            $state.go("tab.deal", { 'tradingNo': $scope.currentTrading.tradingNo });
        }
        $scope.goEvaluate = function () {
            $scope.divShow = { 'div1': false, 'div2': false, 'div3': true, 'div4': false };
            if ($scope.evaluateTypes.length == 0) {
                $http({ method: "POST", url: $rootScope._serverSvc + "getEvaluateType", data: {} })
                .success(function (sdata) {
                    $scope.evaluateTypes = JSON.parse(sdata.d);
                })
            }
        }
        $scope.setStarSrc = function (index) {
            $scope.input.evaluateType = index;
            $scope.message.div3 = "";
            if (index >= 5) {
                $scope.starSrc.star5 = "img/one.png";
            }
            else {
                $scope.starSrc.star5 = "img/zero.png";
            }
            if (index >= 4) {
                $scope.starSrc.star4 = "img/one.png";
            }
            else {
                $scope.starSrc.star4 = "img/zero.png";
            }
            if (index >= 3) {
                $scope.starSrc.star3 = "img/one.png";
            }
            else {
                $scope.starSrc.star3 = "img/zero.png";
            }
            if (index >= 2) {
                $scope.starSrc.star2 = "img/one.png";
            }
            else {
                $scope.starSrc.star2 = "img/zero.png";
            }
            if (index >= 1) {
                $scope.starSrc.star1 = "img/one.png";
            }
            else {
                $scope.starSrc.star1 = "img/zero.png";
            }
            if (index < 1) {
                $scope.evaluateDescription = "";
            }
            else {
                var i;
                for (i = 0; i <= $scope.evaluateTypes.length - 1; i++) {
                    if ($scope.evaluateTypes[i].id == index) {
                        $scope.evaluateDescription = $scope.evaluateTypes[i].name;
                        break;
                    }
                }
            }
        }
        $scope.clickStar = function (index) {
            $scope.setStarSrc(index);
        }
        $scope.evaluateTrading = function () {
            if ($scope.input.evaluateType > 0) {
                $http({ method: "POST", url: $rootScope._serverSvc + "evaluateTrading", data: { 'mid': UserSecurity.mid, 'token': UserSecurity.token, 'tn': $scope.currentTrading.tradingNo, 'type': $scope.input.evaluateType, 'content': $scope.input.evaluateContent } })
                    .success(function (sdata) {
                        console.log(sdata);
                        var tradingData = JSON.parse(sdata.d);
                        if (tradingData.status == "Done") {
                            $scope.divShow = { 'div1': false, 'div2': false, 'div3': false, 'div4': true };
                            $scope.getTradingInit();
                        }
                        else {
                            $scope.message.div3 = tradingData.message;
                        }
                    })
            }
            else {
                $scope.message.div3 = "请点击星星评分之后再提交评价";
            }
        }
        $scope.goBack = function () {
            if ($scope.divShow.div1) {
                $ionicViewSwitcher.nextDirection("back");
                if ($ionicHistory.backView()) {
                    $ionicHistory.goBack();
                } else {
                    $state.go('tab.mine');
                }
            }
            else {
                $scope.divShow = { 'div1': true, 'div2': false, 'div3': false, 'div4': false };
                $scope.message = { 'div1': "", 'div2': "", 'div3': "" };
                $scope.input = { 'evaluateContent': "", 'evaluateType': '1' };
                $scope.currentTrading = {};
                $scope.setStarSrc(0);
            }
        }
        $scope.moreDataCanBeLoaded = function () {
            return !$scope.firstTradingGeted;
        }
        $scope.init();
    })

    .controller('myRechargeControl', function ($scope, $rootScope, $http, $state, UserSecurity) {
        $scope.init = function () {
            $scope.rechargeList = [];
            $scope.firstRechargeGeted = false;
            $scope.message = { 'error': "" };
            $scope.getRechargeInit();
        }
        $scope.getRechargeInit = function () {
            $http({ method: "POST", url: $rootScope._serverSvc + "getMemberRechargeRecord", data: { 'mid': UserSecurity.mid, 'token': UserSecurity.token, 'earliestTime': "" } })
               .success(function (sdata) {
                   var rechargeData = JSON.parse(sdata.d);
                   if (rechargeData.status == "Done") {
                       if (rechargeData.value == "{}") {
                           $scope.firstRechargeGeted = true;
                       }
                       else {
                           $scope.rechargeList = JSON.parse(rechargeData.value);
                       }
                   }
                   else {
                       $scope.message.error = rechargeData.message;
                   }
               })
        }
        $scope.getRechargeHistory = function () {
            if (!$scope.firstRechargeGeted && $scope.rechargeList.length > 0) {
                $http({ method: "POST", url: $rootScope._serverSvc + "getMemberRechargeRecord", data: { 'mid': UserSecurity.mid, 'token': UserSecurity.token, 'earliestTime': $scope.rechargeList[$scope.rechargeList.length - 1].completeTime } })
                    .success(function (sdata) {
                        var rechargeData = JSON.parse(sdata.d);
                        if (rechargeData.status == "Done") {
                            var historyRecharge = JSON.parse(rechargeData.value);
                            if (historyRecharge.length > 0) {
                                var i;
                                for (i = 0; i <= historyRecharge.length - 1; i++) {
                                    $scope.rechargeList.push(historyRecharge[i]);
                                }
                            }
                            else {
                                $scope.firstRechargeGeted = true;
                            }
                        }
                    })
                    .finally(function () {
                        $scope.$broadcast("scroll.infiniteScrollComplete");
                    });
            }
        }
        $scope.moreDataCanBeLoaded = function () {
            return !$scope.firstRechargeGeted;
        }
        $scope.init();
    })

    .controller('myPersonInfoControl', function ($scope, $rootScope, $http, $state, $ionicHistory, $ionicViewSwitcher, UserSecurity) {
        $scope.init = function () {
            $scope.divShow = { 'div1': true, 'div2': false };
            $scope.message = { 'div1': "" };
            $scope.memberInfo = {};
            $scope.sexSelect = ['男', '女'];
            $scope.getMemberInfo();
        }
        $scope.getMemberInfo = function () {
            $http({ method: "POST", url: $rootScope._serverSvc + "getMemberInfo", data: { 'mid': UserSecurity.mid, 'token': UserSecurity.token } })
                .success(function (sdata) {
                    if (sdata.d != "{}") {
                        $scope.memberInfo = JSON.parse(sdata.d);
                        $rootScope._memberInfo.balanceNum = $scope.memberInfo.balance;
                        $rootScope._memberInfo.scoreNum = $scope.memberInfo.score;
                        $rootScope._memberInfo.keyNum = $scope.memberInfo.boxKey;
                    }
                    else {
                        UserSecurity.checked = false;
                        $state.go("login");
                    }
                })
        }
        $scope.doCommit = function () {
            console.log($scope.memberInfo)
            $http({ method: "POST", url: $rootScope._serverSvc + "updateMemberPersonalInfo", data: { 'mid': UserSecurity.mid, 'token': UserSecurity.token, 'name': $scope.memberInfo.name, 'sex': $scope.memberInfo.sex, 'address': $scope.memberInfo.address, 'email': $scope.memberInfo.email } })
                .success(function (sdata) {
                    var updateData = JSON.parse(sdata.d);
                    if (updateData.status == "Done") {
                        $scope.divShow = { 'div1': false, 'div2': true };
                    }
                    else {
                        $scope.message.div1 = updateData.message;
                    }
                })
        }
        $scope.goBack = function () {
            $ionicViewSwitcher.nextDirection("back");
            if ($ionicHistory.backView()) {
                $ionicHistory.goBack();
            } else {
                $state.go('tab.mine');
            }
        }
        $scope.init();
    })

    .controller('myHeadImageControl', function ($scope, $rootScope, $http, $state, $ionicHistory, $ionicViewSwitcher, UserSecurity) {
        $scope.init = function () {
            $scope.divShow = { 'div1': true, 'div2': false, 'div3': false };
            $scope.message = { 'div1': "", 'div2': "" };
            $scope.memberImage = { 'showUrl': null };
            $scope.imageData = { 'showUrl': null, 'uploadUrl': null };
            $scope.getMemberInfo();
        }
        $scope.getMemberInfo = function () {
            $http({ method: "POST", url: $rootScope._serverSvc + "getMemberInfo", data: { 'mid': UserSecurity.mid, 'token': UserSecurity.token } })
                .success(function (sdata) {
                    if (sdata.d != "{}") {
                        var serverData = JSON.parse(sdata.d);
                        if (serverData.headImage == "") {
                            $scope.memberImage.showUrl = "Images/App/Users/defaultHeadImage.png";
                        }
                        else {
                            $scope.memberImage.showUrl = serverData.headImage;
                        }
                    }
                });
        }
        $scope.getPicture = function (sourceType) {
            var options = {
                'quality': 100,
                'destinationType': 1,//FILE_URI
                'sourceType': 1,//0-PHOTOLIBRARY,1-CAMERA,2-SAVEDPHOTOALBUM
                'allowEdit': true,
                'encodingType': 0,//0-JPEG,1-PNG
                'targetWidth': 200,
                'targetHeight': 200,
                'mediaType': 0//0-PICTURE,1-VIDEO,2-ALLMEDIA
            };
            if (sourceType == 0) {
                options.sourceType = 0;
            }
            navigator.camera.getPicture($scope.cameraSuccess, $scope.cameraError, options);
        }
        $scope.cameraSuccess = function (imgData) {
            if (imgData != null) {
                $scope.imageData.showUrl = imgData;
                window.resolveLocalFileSystemURL(imgData,
                    function (fileEntry) {
                        $scope.imageData.uploadUrl = fileEntry.toInternalURL();
                        $scope.$apply(function () {
                            $scope.divShow = { 'div1': false, 'div2': true, 'div3': false };
                        });
                    },
                    function () {
                        $scope.message.div1 = "转换图片地址失败";
                    });
            }
            else {
                $scope.message.div1 = "未选取图片";
            }
        }
        $scope.cameraError = function () {
            $scope.message.div1 = "无法获取图片";
        }
        $scope.upload = function () {
            var options = new FileUploadOptions();
            options.fileKey = "headImage";
            options.fileName = "hi.jpg";
            options.mimeType = "image/jpeg";
            options.params = { 'type': "UploadMemberHeadImage", 'mid': UserSecurity.mid, 'token': UserSecurity.token };
            var uploader = new FileTransfer();
            uploader.upload($scope.imageData.uploadUrl, encodeURI($rootScope._fileUploadProcessor), $scope.uploadSuccess, $scope.uploadError, options, true);
        }
        $scope.uploadSuccess = function (sdata) {
            var uploadData = JSON.parse(sdata.response);
            if (uploadData.status == "Done") {
                $scope.getMemberInfo();
                $scope.$apply(function () {
                    $scope.divShow = { 'div1': false, 'div2': false, 'div3': true };
                });
            }
            else {
                $scope.$apply(function () {
                    $scope.message.div2 = "图片上传失败" + uploadData.message;
                })
            }
        }
        $scope.uploadError = function (error) {
            $scope.$apply(function () {
                $scope.message.div2 = "图片上传失败";
            })
        }
        $scope.goBack = function () {
            if ($scope.divShow.div1) {
                $ionicViewSwitcher.nextDirection("back");
                if ($ionicHistory.backView()) {
                    $ionicHistory.goBack();
                } else {
                    $state.go('tab.mine');
                }
            }
            else {
                $scope.divShow = { 'div1': true, 'div2': false, 'div3': false };
            }
        }
        $scope.init();
    })

    .controller('myWechatShareControl', function ($scope, $rootScope, $http, $state, $ionicHistory, $ionicViewSwitcher, UserSecurity) {
        $scope.init = function () {
            $scope.message = { 'error': "" };
            $scope.shareData = null;
            $scope.getShareData();
        }
        $scope.getShareData = function () {
            $http({ method: "POST", url: $rootScope._serverSvc + "getMemberWechatShare", data: {} })
                .success(function (sdata) {
                    var serverData = JSON.parse(sdata.d);
                    if (serverData.status == "Done") {
                        $scope.shareData = JSON.parse(serverData.value);
                    }
                    else {
                        $scope.message.error = serverData.message;
                    }
                });
        }
        $scope.share0 = function () {
            Wechat.isInstalled(function (installed) {
                if (installed) {
                    Wechat.share({
                        message: {
                            title: $scope.shareData.title,
                            description: $scope.shareData.description,
                            thumb: $rootScope._serverUrl + $scope.shareData.imageUrl,
                            media: {
                                type: Wechat.Type.WEBPAGE,
                                webpageUrl: $scope.shareData.pageUrl
                            }
                        },
                        scene: Wechat.Scene.SESSION
                    }, function () {
                        $http({ method: "POST", url: $rootScope._serverSvc + "addMemberShareRecord", data: { 'mid': UserSecurity.mid, 'token': UserSecurity.token, 'type': $scope.shareData.stageName, 'scene': 0 } })
                            .success(function (sdata) {
                                var serverData = JSON.parse(sdata.d);
                                if (serverData.status == "Done") {
                                    $scope.message.error = "分享成功";
                                }
                                else {
                                    $scope.message.error = serverData.message;
                                }
                            });
                    }, function (reason) {
                        $scope.$apply(function () {
                            $scope.message.error = reason;
                        })
                    });
                }
                else {
                    $scope.message.error = "您的手机上未安装微信";
                }
            }, function (reason) {
                $scope.$apply(function () {
                    $scope.message.error = reason;
                });
            });
        }
        $scope.share1 = function () {
            Wechat.isInstalled(function (installed) {
                if (installed) {
                    Wechat.share({
                        message: {
                            title: $scope.shareData.title,
                            description: $scope.shareData.description,
                            thumb: $rootScope._serverUrl + $scope.shareData.imageUrl,
                            media: {
                                type: Wechat.Type.WEBPAGE,
                                webpageUrl: $scope.shareData.pageUrl
                            }
                        },
                        scene: Wechat.Scene.TIMELINE
                    }, function () {
                        $http({ method: "POST", url: $rootScope._serverSvc + "addMemberShareRecord", data: { 'mid': UserSecurity.mid, 'token': UserSecurity.token, 'type': $scope.shareData.stageName, 'scene': 1 } })
                            .success(function (sdata) {
                                console.log(sdata);
                                var serverData = JSON.parse(sdata.d);
                                if (serverData.status == "Done") {
                                    $scope.message.error = "分享成功";
                                }
                                else {
                                    $scope.message.error = serverData.message;
                                }
                            });
                    }, function (reason) {
                        $scope.$apply(function () {
                            $scope.message.error = reason;
                        })
                    });
                }
                else {
                    $scope.message.error = "您的手机上未安装微信";
                }
            }, function (reason) {
                $scope.$apply(function () {
                    $scope.message.error = reason;
                });
            });
        }
        $scope.goBack = function () {
            $ionicViewSwitcher.nextDirection("back");
            if ($ionicHistory.backView()) {
                $ionicHistory.goBack();
            } else {
                $state.go('tab.mine');
            }
        }
        $scope.init();
    })

    .controller('myCustomerServiceControl', function ($scope, $ionicHistory, $ionicViewSwitcher) {
        $scope.goBack = function () {
            $ionicViewSwitcher.nextDirection("back");
            if ($ionicHistory.backView()) {
                $ionicHistory.goBack();
            } else {
                $state.go('tab.mine');
            }
        }
        $scope.goIndex = function () {
            cordova.InAppBrowser.open("http://www.bentuhui.com/", '_blank', 'location=no');
        }
    })

    .controller('mySuggestControl', function ($scope, $rootScope, $http, $state, $ionicHistory, $ionicViewSwitcher, UserSecurity) {
        $scope.init = function () {
            $scope.divShow = { 'div1': true, 'div2': false }
            $scope.message = { 'error': "" };
            $scope.input = { 'content': "" };
            $scope.valid = { 'commit': true };
        }
        $scope.saveSuggest = function () {
            if ($scope.valid.commit) {
                $scope.valid.commit = false;
                if ($scope.input.content.length >= 6) {
                    $http({ method: "POST", url: $rootScope._serverSvc + "saveMemberSuggest", data: { 'mid': UserSecurity.mid, 'token': UserSecurity.token, 'content': $scope.input.content } })
                        .success(function (sdata) {
                            var serverData = JSON.parse(sdata.d);
                            if (serverData.status == "Done") {
                                $scope.input.content = "";

                                $scope.divShow = { 'div1': false, 'div2': true }
                            }
                            else {
                                $scope.message.error = serverData.message;
                            }
                            $scope.valid.commit = true;
                        });
                }
                else {
                    $scope.message.error = "写点东西再提交吧...";
                    $scope.valid.commit = true;
                }
            }
        }
        $scope.goBack = function () {
            if ($scope.divShow.div1) {
                $ionicViewSwitcher.nextDirection("back");
                if ($ionicHistory.backView()) {
                    $ionicHistory.goBack();
                } else {
                    $state.go('tab.mine');
                }
            }
            else {
                $scope.divShow = { 'div1': true, 'div2': false };
                $scope.message = { 'error': '' };
            }
        }
        $scope.init();
    })

    .controller('myRecommendControl', function ($scope, $rootScope, $http, $state, $ionicHistory, $ionicViewSwitcher, UserSecurity) {
        $scope.init = function () {
            $scope.divShow = { 'div1': true, 'div2': false }
            $scope.message = { 'error': "" };
            $scope.input = { 'storeName': "", 'address': "", 'reason': "", 'contractName': "", 'cellNumber': "", 'otherInfo': "" };
            $scope.valid = { 'commit': true };
        }
        $scope.saveSuggest = function () {
            if ($scope.valid.commit) {
                $scope.valid.commit = false;
                if ($scope.input.storeName.length >= 2) {
                    if ($scope.input.address.length >= 3) {
                        if ($scope.input.reason.length >= 2) {
                            $http({ method: "POST", url: $rootScope._serverSvc + "saveMemberRecommend", data: { 'mid': UserSecurity.mid, 'token': UserSecurity.token, 'storeName': $scope.input.storeName, 'address': $scope.input.address, 'reason': $scope.input.reason, 'contractName': $scope.input.contractName, 'cellNumber': $scope.input.cellNumber, 'otherInfo': $scope.input.otherInfo } })
                                .success(function (sdata) {
                                    var serverData = JSON.parse(sdata.d);
                                    if (serverData.status == "Done") {
                                        $scope.input = { 'storeName': "", 'address': "", 'reason': "", 'contractName': "", 'cellNumber': "", 'otherInfo': "" };

                                        $scope.divShow = { 'div1': false, 'div2': true }
                                    }
                                    else {
                                        $scope.message.error = serverData.message;
                                    }
                                    $scope.valid.commit = true;
                                });
                        }
                        else {
                            $scope.message.error = "请填写一下您推荐的理由";
                            $scope.valid.commit = true;
                        }
                    }
                    else {
                        $scope.message.error = "请填写一下店铺的地址";
                        $scope.valid.commit = true;
                    }
                }
                else {
                    $scope.message.error = "请填写一下店铺的名称";
                    $scope.valid.commit = true;
                }
            }
        }
        $scope.goBack = function () {
            if ($scope.divShow.div1) {
                $ionicViewSwitcher.nextDirection("back");
                if ($ionicHistory.backView()) {
                    $ionicHistory.goBack();
                } else {
                    $state.go('tab.mine');
                }
            }
            else {
                $scope.divShow = { 'div1': true, 'div2': false };
                $scope.message = { 'error': '' };
            }
        }
        $scope.init();
    })

    .controller('boxDrawControl', function ($scope, $rootScope, $http, $state, $timeout, $ionicPopup, $ionicHistory, $ionicViewSwitcher, UserSecurity, UserLocation) {
        $scope.$on('$ionicView.enter', function () {
            if (UserSecurity.checked) {
                if (!$scope.drawEnable) {
                    $scope.getCurrentBatch();
                }
                else {
                    $scope.getKeyNum();
                }
            }
            else {
                $state.go("login");
            }
        });
        $scope.init = function () {
            $scope.divShow = { 'div1': true, 'div2': false, 'div3': false, 'div4': false };
            $scope.boxInfo = [
                { 'type': 3, 'imageUrl': "img/background.png" },
                { 'type': 3, 'imageUrl': "img/background.png" },
                { 'type': 3, 'imageUrl': "img/background.png" },
                { 'type': 3, 'imageUrl': "img/background.png" },
                { 'type': 3, 'imageUrl': "img/background.png" },
                { 'type': 3, 'imageUrl': "img/background.png" }];
            $scope.batchInfo = {};
            $scope.drawResult = {};
            $scope.broadcastData = [];
            $scope.broadcastMessage = { 'message1': "", 'message2': "", 'index': 0, 'refresh': true };
            $scope.prizeImageUrl = "";
            $scope.autoBackTimer = null;
            $scope.drawEnable = false;
        }
        $scope.getCurrentBatch = function () {
            if (UserLocation.locationStatus == "Selected") {
                var confirmPopup = $ionicPopup.confirm({ title: '位置提示', template: '<p style="text-indent:2em;">您目前的位置是通过手动定位获得的，如果抽中实物奖品仍然需要到您所选择的地区领取，通过主页的刷新位置功能可以切换到您的实际位置，如果您想要回到主页，请点击“取消”，想继续在现有位置抽奖，请点击“确定”</p>', cancelText: '取消', okText: '确定' });
                confirmPopup.then(function (res) {
                    if (!res) {
                        $scope.drawEnable = false;
                        $ionicViewSwitcher.nextDirection("back");
                        $state.go('tab.home');
                    }
                });
            }
            $http({ method: "POST", url: $rootScope._serverSvc + "getCurrentDrawBatch", data: { 'locationX': UserLocation.locationX, 'locationY': UserLocation.locationY } })
                .success(function (sdata) {
                    var drawData = JSON.parse(sdata.d);
                    if (drawData.status == "Done") {
                        if (drawData.value != "{}") {
                            $scope.batchInfo = JSON.parse(drawData.value);
                            $scope.drawEnable = true;
                            $scope.boxInfo = [
                                { 'type': 0, 'imageUrl': $rootScope._serverUrl + "Images/App/DrawPrize/box.gif" },
                                { 'type': 0, 'imageUrl': $rootScope._serverUrl + "Images/App/DrawPrize/box.gif" },
                                { 'type': 0, 'imageUrl': $rootScope._serverUrl + "Images/App/DrawPrize/box.gif" },
                                { 'type': 0, 'imageUrl': $rootScope._serverUrl + "Images/App/DrawPrize/box.gif" },
                                { 'type': 0, 'imageUrl': $rootScope._serverUrl + "Images/App/DrawPrize/box.gif" },
                                { 'type': 0, 'imageUrl': $rootScope._serverUrl + "Images/App/DrawPrize/box.gif" }];
                            $scope.getDrawBroadcastData();
                        }
                        else {
                            $scope.drawEnable = false;
                            var myPopup = $ionicPopup.show({
                                title: '抱歉，您所在的区域目前未开展开箱子抽奖活动',
                                buttons: [{ text: '朕知道了', type: 'button-positive' }]
                            });
                            myPopup.then();
                        }
                        $scope.getKeyNum();
                    }
                    else {
                        window.plugins.toast.showLongBottom(drawData.message);
                    }
                });
        }
        $scope.getKeyNum = function () {
            if ($rootScope._memberInfo.keyNum == null) {
                $http({ method: "POST", url: $rootScope._serverSvc + "getMemberKeyNumber", data: { 'mid': UserSecurity.mid, 'token': UserSecurity.token } })
                    .success(function (sdata) {
                        var drawData = JSON.parse(sdata.d);
                        if (drawData.status == "Done") {
                            $rootScope._memberInfo.keyNum = drawData.value;
                        }
                        else {
                            window.plugins.toast.showLongBottom(drawData.message);
                        }
                    });
            }

        }
        $scope.draw = function (boxIndex) {
            if ($scope.boxInfo[boxIndex].type == 0 && $scope.drawEnable) {
                $http({ method: "POST", url: $rootScope._serverSvc + "openDrawBoxOnce", data: { 'mid': UserSecurity.mid, 'token': UserSecurity.token, 'bid': $scope.batchInfo.id, 'locationX': UserLocation.locationX, 'locationY': UserLocation.locationY } })
                    .success(function (sdata) {
                        var drawData = JSON.parse(sdata.d);
                        if (drawData.status == "Done") {
                            $scope.drawResult = JSON.parse(drawData.value);
                            if ($scope.drawResult.hasPrize == "Yes") {
                                $scope.divShow = { 'div1': true, 'div2': true, 'div3': false, 'div4': false };
                                $scope.boxInfo[boxIndex].imageUrl = $rootScope._serverUrl + $scope.drawResult.prizeImage;
                                $scope.prizeImageUrl = $rootScope._serverUrl + $scope.drawResult.prizeImage;
                                $scope.boxInfo[boxIndex].type = 1;
                            }
                            else {
                                $scope.divShow = { 'div1': true, 'div2': false, 'div3': true, 'div4': false };
                                $scope.boxInfo[boxIndex].imageUrl = $rootScope._serverUrl + "Images/App/DrawPrize/empty.png";
                                $scope.boxInfo[boxIndex].type = 2;
                            }
                            $rootScope._memberInfo.keyNum--;
                            //3秒钟后自动返回清除DIV2和DIV3
                            //$scope.autoBackTimer = $timeout(function () {
                            //    $scope.divShow = { 'div1': true, 'div2': false, 'div3': false };
                            //}, 3000)
                        }
                        else {
                            window.plugins.toast.showLongBottom(drawData.message);
                        }
                    });
            }
            else {
                if ($scope.boxInfo[boxIndex].type == 1) {
                    $state.go('myDraw');
                }
            }
        }
        $scope.refreshBox = function () {
            if ($scope.drawEnable) {
                $scope.boxInfo = [
                    { 'type': 3, 'imageUrl': "img/background.png" },
                    { 'type': 3, 'imageUrl': "img/background.png" },
                    { 'type': 3, 'imageUrl': "img/background.png" },
                    { 'type': 3, 'imageUrl': "img/background.png" },
                    { 'type': 3, 'imageUrl': "img/background.png" },
                    { 'type': 3, 'imageUrl': "img/background.png" }];
                $timeout(function () { $scope.boxInfo[0] = { 'type': 0, 'imageUrl': $rootScope._serverUrl + "Images/App/DrawPrize/box.gif" } }, 200);
                $timeout(function () { $scope.boxInfo[1] = { 'type': 0, 'imageUrl': $rootScope._serverUrl + "Images/App/DrawPrize/box.gif" } }, 400);
                $timeout(function () { $scope.boxInfo[2] = { 'type': 0, 'imageUrl': $rootScope._serverUrl + "Images/App/DrawPrize/box.gif" } }, 600);
                $timeout(function () { $scope.boxInfo[3] = { 'type': 0, 'imageUrl': $rootScope._serverUrl + "Images/App/DrawPrize/box.gif" } }, 800);
                $timeout(function () { $scope.boxInfo[4] = { 'type': 0, 'imageUrl': $rootScope._serverUrl + "Images/App/DrawPrize/box.gif" } }, 1000);
                $timeout(function () { $scope.boxInfo[5] = { 'type': 0, 'imageUrl': $rootScope._serverUrl + "Images/App/DrawPrize/box.gif" } }, 1200);
            }
        }
        $scope.getDrawBroadcastData = function () {
            $http({ method: "POST", url: $rootScope._serverSvc + "getMemberPrizeBroadcast", data: { 'bid': $scope.batchInfo.id } })
                .success(function (sdata) {
                    $scope.broadcastData = JSON.parse(sdata.d);
                    $scope.broadcastMessage.index = 0;
                    $scope.showDrawBroadcastMessage();
                })
                .error(function (error) {
                    console.log($scope.batchInfo);
                });
        }
        $scope.showDrawBroadcastMessage = function () {
            if ($scope.broadcastMessage.index >= $scope.broadcastData.length - 1) {
                $scope.getDrawBroadcastData();
            }
            else {
                if ($scope.broadcastMessage.refresh) {
                    $scope.broadcastMessage.message1 = "恭喜 " + $scope.broadcastData[$scope.broadcastMessage.index].memberName + " 获得了 " + $scope.broadcastData[$scope.broadcastMessage.index].bonusName + "!      " + $scope.broadcastData[$scope.broadcastMessage.index].openTime;
                    $scope.broadcastMessage.message2 = "恭喜 " + $scope.broadcastData[$scope.broadcastMessage.index + 1].memberName + " 获得了 " + $scope.broadcastData[$scope.broadcastMessage.index + 1].bonusName + "!      " + $scope.broadcastData[$scope.broadcastMessage.index + 1].openTime;
                    $scope.broadcastMessage.index += 2;
                }
                $timeout($scope.showDrawBroadcastMessage, 2000);
            }
        }
        $scope.goBatchInfo = function () {
            $scope.divShow = { 'div1': false, 'div2': false, 'div3': false, 'div4': true };
        }
        $scope.goBack = function () {
            if ($scope.divShow.div1 && !$scope.divShow.div2 && !$scope.divShow.div3 && !$scope.divShow.div4) {
                $ionicViewSwitcher.nextDirection("back");
                if ($ionicHistory.backView()) {
                    $ionicHistory.goBack();
                } else {
                    $state.go('tab.mine');
                }
            }
            else {
                $scope.divShow = { 'div1': true, 'div2': false, 'div3': false, 'div4': false };
                //$timeout.cancel($scope.autoBackTimer);
            }
        }
        $scope.init();
    })

    .controller('selectPositionControl', function ($scope, $rootScope, $http, $state, $ionicViewSwitcher, UserLocation) {
        $scope.init = function () {
            $scope.provinces = [];
            $scope.citys = [];
            $scope.districts = [];
            $scope.points = [];
            $scope.input = { 'currentProvince': null, 'currentCity': null, 'currentDistrict': null, 'currentPoint': null };
            $scope.message = { 'error': "" };
            $scope.getProvinces();
        }
        $scope.getProvinces = function () {
            $http({ method: "POST", url: $rootScope._serverSvc + "getProvincesLaunched", data: {} })
               .success(function (sdata) {
                   $scope.provinces = JSON.parse(sdata.d);
                   if ($scope.provinces.length > 0) {
                       $scope.getCitys();
                   }
               });
        }
        $scope.getCitys = function () {
            $http({ method: "POST", url: $rootScope._serverSvc + "getCitysLaunched", data: {} })
               .success(function (sdata) {
                   var serverData = JSON.parse(sdata.d);
                   var i, j;
                   for (i = 0; i <= $scope.provinces.length - 1; i++) {
                       $scope.provinces[i].citys = [];
                       for (j = 0; j <= serverData.length - 1; j++) {
                           if (serverData[j].parent == $scope.provinces[i].id) {
                               $scope.provinces[i].citys.push(serverData[j]);
                           }
                       }
                   }
                   $scope.getDistricts();
               });
        }
        $scope.getDistricts = function () {
            $http({ method: "POST", url: $rootScope._serverSvc + "getDistrictsLaunched", data: {} })
               .success(function (sdata) {
                   var serverData = JSON.parse(sdata.d);
                   var i, j, k;
                   for (i = 0; i <= $scope.provinces.length - 1; i++) {
                       for (j = 0; j <= $scope.provinces[i].citys.length - 1; j++) {
                           $scope.provinces[i].citys[j].districts = [];
                           for (k = 0; k <= serverData.length - 1; k++) {
                               if (serverData[k].parent == $scope.provinces[i].citys[j].id) {
                                   $scope.provinces[i].citys[j].districts.push(serverData[k]);
                               }
                           }
                       }
                   }
                   $scope.input.currentProvince = $scope.provinces[0];
                   $scope.provinceChanged();
               });
        }
        $scope.provinceChanged = function () {
            if ($scope.input.currentProvince.citys.length > 0) {
                $scope.citys = $scope.input.currentProvince.citys;
                $scope.input.currentCity = $scope.citys[0];
                $scope.cityChanged();
            }
            else {
                $scope.citys = [];
                $scope.districts = [];
                $scope.points = [];
            }

        }
        $scope.cityChanged = function () {
            if ($scope.input.currentCity.districts.length > 0) {
                $scope.districts = $scope.input.currentCity.districts;
                $scope.input.currentDistrict = $scope.districts[0];
                $scope.districtChanged();
            }
            else {
                $scope.districts = [];
                $scope.points = [];
            }
        }
        $scope.districtChanged = function () {
            if (typeof ($scope.input.currentDistrict.points) != "undefined") {
                if ($scope.input.currentDistrict.points.length > 0) {
                    $scope.points = $scope.input.currentDistrict.points;
                    $scope.input.currentPoint = $scope.points[0];
                }
                else {
                    $scope.points = [];
                }
            }
            else {
                $scope.getPoints($scope.input.currentDistrict.id);
            }
        }
        $scope.getPoints = function (districtID) {
            $http({ method: "POST", url: $rootScope._serverSvc + "getDistrictPoints", data: { 'did': districtID } })
               .success(function (sdata) {
                   $scope.input.currentDistrict.points = JSON.parse(sdata.d);
                   $scope.districtChanged();
               });
        }
        $scope.setPosition = function () {
            if ($scope.input.currentPoint != null) {
                UserLocation.located = true;
                UserLocation.decoded = true;
                UserLocation.locationX = $scope.input.currentPoint.x;
                UserLocation.locationY = $scope.input.currentPoint.y;
                UserLocation.locationName = $scope.input.currentPoint.name;
                UserLocation.locationStatus = "Selected";
                $ionicViewSwitcher.nextDirection("back");
                $state.go('tab.home');
            }
            else {
                $scope.message.error = "请先选择一个位置";
            }
        }
        $scope.init();
    })

    .controller('storeSearchControl', function ($scope, $rootScope, $http, UserLocation) {
        $scope.init = function () {
            $scope.serviceType = null;
            $scope.service = null;
            $scope.serviceInType = null;
            $scope.StoreList = null;
            $scope.lastStoreGeted = true;
            $scope.rangeOptions = [{ 'id': 0, 'name': "不限范围" }, { 'id': 1, 'name': "5千米" }, { 'id': 2, 'name': "10千米" }, { 'id': 3, 'name': "20千米" }];
            $scope.orderOptions = [{ 'id': 0, 'name': "距离最近" }, { 'id': 1, 'name': "折扣最大" }, { 'id': 2, 'name': "评分最高" }];
            $scope.input = { 'searchKey': null, 'rangeOption': 0, 'orderOption': 0, 'serviceTypeOption': 0, 'serviceOption': 0 };
            $scope.getServiceType();
        }
        $scope.getServiceType = function () {
            $http({ method: "POST", url: $rootScope._serverSvc + "getServiceType", data: {} })
                .success(function (sdata) {
                    var typeData = JSON.parse(sdata.d);
                    $scope.serviceType = [];
                    $scope.serviceType.push({ 'id': 0, 'name': "全部类别" });
                    for (var i = 0; i <= typeData.length - 1; i++) {
                        if (typeData[i].showLevel == 1) {
                            $scope.serviceType.push({ 'id': typeData[i].id, 'name': typeData[i].name });
                        }
                    }
                    $scope.getServiceList();
                });
        }
        $scope.getServiceList = function () {
            $http({ method: "POST", url: $rootScope._serverSvc + "getServiceList", data: {} })
               .success(function (sdata) {
                   var serviceData = JSON.parse(sdata.d);
                   $scope.service = [];
                   for (var i = 0; i <= serviceData.length - 1; i++) {
                       $scope.service.push({ 'id': serviceData[i].id, 'name': serviceData[i].name, 'typeId': serviceData[i].typeId });
                   }
                   $scope.setCurrentServiceType();
               });
        }
        $scope.setCurrentServiceType = function () {
            $scope.input.serviceOption = 0;
            $scope.serviceInType = [];
            $scope.serviceInType.push({ 'id': 0, 'name': "全部分类" });
            for (var i = 0; i <= $scope.service.length - 1; i++) {
                if ($scope.input.serviceTypeOption == 0 || $scope.service[i].typeId == $scope.input.serviceTypeOption) {
                    $scope.serviceInType.push($scope.service[i]);
                }
            }
        }
        //获取店铺列表
        $scope.getStoreList = function () {
            $http({ method: "POST", url: $rootScope._serverSvc + "getStoreList", data: { 'startNumber': 0, 'locationX': UserLocation.locationX, 'locationY': UserLocation.locationY, 'serviceType': $scope.input.serviceOption == 0 ? $scope.input.serviceTypeOption : 0, 'service': $scope.input.serviceOption, 'range': $scope.input.rangeOption, 'order': $scope.input.orderOption, 'keyword': $scope.input.searchKey } })
               .success(function (sdata) {
                   $scope.StoreList = JSON.parse(sdata.d);
                   if ($scope.StoreList.length > 0) {
                       $scope.lastStoreGeted = false;
                   }
                   else {
                       $scope.lastStoreGeted = true;
                   }
               })
        }
        //获取更多店铺信息
        $scope.getStoreListMore = function () {
            if (!$scope.lastStoreGeted && $scope.StoreList.length > 0) {
                $http({ method: "POST", url: $rootScope._serverSvc + "getStoreList", data: { 'startNumber': $scope.StoreList.length, 'locationX': UserLocation.locationX, 'locationY': UserLocation.locationY, 'serviceType': $scope.input.serviceOption == 0 ? $scope.input.serviceTypeOption : 0, 'service': $scope.input.serviceOption, 'range': $scope.input.rangeOption, 'order': $scope.input.orderOption, 'keyword': $scope.input.searchKey } })
                .success(function (sdata) {
                    var storeData = JSON.parse(sdata.d);
                    if (storeData.length > 0) {
                        var i;
                        for (i = 0; i <= storeData.length - 1; i++) {
                            $scope.StoreList.push(storeData[i]);
                        }
                        $scope.lastStoreGeted = false;
                    }
                    else {
                        $scope.lastStoreGeted = true;
                    }
                })
                .finally(function () {
                    $scope.$broadcast("scroll.infiniteScrollComplete");
                });
            }
        }
        $scope.moreDataCanBeLoaded = function () {
            return !$scope.lastStoreGeted;
        }
        $scope.init();
    })

    .controller('storeDetailControl', function ($scope, $rootScope, $http, $stateParams, $ionicHistory, $ionicViewSwitcher, UserLocation) {
        $scope.init = function () {
            $scope.storeInfo = null;
            $scope.storeImages = null;
            $scope.storeTips = null;
            $scope.storeEvaluate = null;
            $scope.currentImage = null;
            $scope.firstEvaluateGeted = true;
            $scope.getStoreInfo();
        }
        $scope.getStoreInfo = function () {
            $http({ method: "POST", url: $rootScope._serverSvc + "getStoreInfo2", data: { 'sid': $stateParams.storeId } })
                .success(function (sdata) {
                    $scope.storeInfo = JSON.parse(sdata.d);
                    $scope.getStoreImage();
                });
        }
        $scope.getStoreImage = function () {
            $http({ method: "POST", url: $rootScope._serverSvc + "getStoreImageList", data: { 'sid': $stateParams.storeId } })
                .success(function (sdata) {
                    $scope.storeImages = JSON.parse(sdata.d);
                    if ($scope.storeImages.length > 0) {
                        $scope.currentImage = 0;
                    }
                    else {
                        $scope.currentImage = null;
                    }
                    $scope.getStoreTips();
                });
        }
        $scope.goNext = function () {
            if ($scope.currentImage != null && $scope.currentImage < $scope.storeImages.length - 1) {
                $scope.currentImage++;
            }
        }
        $scope.goPrev = function () {
            if ($scope.currentImage != null && $scope.currentImage > 0) {
                $scope.currentImage--;
            }
        }
        $scope.getStoreTips = function () {
            $http({ method: "POST", url: $rootScope._serverSvc + "getStoreConsumerTips", data: { 'sid': $stateParams.storeId } })
                .success(function (sdata) {
                    var tipInfo = JSON.parse(sdata.d);
                    if (tipInfo.status == "Done") {
                        if (tipInfo.value != "{}") {
                            $scope.storeTips = JSON.parse(tipInfo.value);
                        }
                        else {
                            $scope.storeTips = null;
                        }
                    }
                    else {
                        $scope.storeTips = null;
                    }
                    $scope.getStoreEvaluate();
                });
        }
        $scope.getStoreEvaluate = function () {
            $http({ method: "POST", url: $rootScope._serverSvc + "getStoreEvaluateList", data: { 'sid': $stateParams.storeId, 'earliestTime': "" } })
                .success(function (sdata) {
                    var serverData = JSON.parse(sdata.d);
                    if (serverData.status == "Done") {
                        if (serverData.value != "{}") {
                            $scope.storeEvaluate = JSON.parse(serverData.value);
                            $scope.firstEvaluateGeted = false;
                        }
                        else {
                            $scope.storeEvaluate = null;
                        }
                    }
                    else {
                        $scope.storeEvaluate = null;
                    }
                });
        }
        $scope.getStoreEvaluateMore = function () {
            if (!$scope.firstEvaluateGeted && $scope.storeEvaluate.length > 0) {
                $http({ method: "POST", url: $rootScope._serverSvc + "getStoreEvaluateList", data: { 'sid': $stateParams.storeId, 'earliestTime': $scope.storeEvaluate[$scope.storeEvaluate.length - 1].evaluateTime } })
                    .success(function (sdata) {
                        var serverData = JSON.parse(sdata.d);
                        if (serverData.status == "Done") {
                            if (serverData.value != "{}") {
                                var evaluateData = JSON.parse(serverData.value);
                                for (i = 0; i <= evaluateData.length - 1; i++) {
                                    $scope.storeEvaluate.push(evaluateData[i]);
                                }
                            }
                            else {
                                $scope.firstEvaluateGeted = true;
                            }
                        }
                        else {
                            $scope.firstEvaluateGeted = true;
                        }
                    })
                    .finally(function () {
                        $scope.$broadcast("scroll.infiniteScrollComplete");
                    });
            }
        }
        $scope.moreDataCanBeLoaded = function () {
            return !$scope.firstEvaluateGeted;
        }
        $scope.goBack = function () {
            $ionicViewSwitcher.nextDirection("back");
            if ($ionicHistory.backView()) {
                $ionicHistory.goBack();
            } else {
                $state.go('tab.home');
            }
        }
        $scope.init();
    })

    .controller('storeClassifyControl', function ($scope, $rootScope, $http, $state, $stateParams, UserLocation) {
        $scope.$on('$ionicView.enter', function () {
            if ($scope.currentServiceTypeIndex != null && $scope.serviceType[$scope.currentServiceTypeIndex].id != $stateParams.classifyId) {
                $scope.input = { 'rangeOption': 0, 'orderOption': 0, 'serviceOption': 0 };
                $scope.setCurrentServiceType();
            }
        });
        $scope.init = function () {
            $scope.serviceType = null;
            $scope.currentServiceTypeIndex = null;
            $scope.service = null;
            $scope.serviceInType = null;
            $scope.StoreList = null;
            $scope.lastStoreGeted = true;
            $scope.rangeOptions = [{ 'id': 0, 'name': "不限范围" }, { 'id': 1, 'name': "5千米" }, { 'id': 2, 'name': "10千米" }, { 'id': 3, 'name': "20千米" }];
            $scope.orderOptions = [{ 'id': 0, 'name': "距离最近" }, { 'id': 1, 'name': "折扣最大" }, { 'id': 2, 'name': "评分最高" }];
            $scope.input = { 'rangeOption': 0, 'orderOption': 0, 'serviceOption': 0 };
            $scope.currentClassifyName = "";
            $scope.getServiceType();
        }
        $scope.getServiceType = function () {
            $http({ method: "POST", url: $rootScope._serverSvc + "getServiceType", data: {} })
                .success(function (sdata) {
                    $scope.serviceType = JSON.parse(sdata.d);
                    $scope.getServiceList();
                });
        }
        $scope.getServiceList = function () {
            $http({ method: "POST", url: $rootScope._serverSvc + "getServiceList", data: {} })
               .success(function (sdata) {
                   $scope.service = JSON.parse(sdata.d);
                   $scope.setCurrentServiceType();
               });
        }
        $scope.setCurrentServiceType = function () {
            if ($scope.serviceType != null) {
                var i;
                for (i = 0; i <= $scope.serviceType.length - 1; i++) {
                    if ($scope.serviceType[i].id == $stateParams.classifyId) {
                        $scope.currentServiceTypeIndex = i;
                        $scope.currentClassifyName = $scope.serviceType[i].name;
                        $scope.serviceInType = [];
                        $scope.serviceInType.push({ 'id': 0, 'name': "全部分类" });
                        var j;
                        for (j = 0; j <= $scope.service.length - 1; j++) {
                            if ($scope.service[j].typeId == $stateParams.classifyId) {
                                $scope.serviceInType.push($scope.service[j]);
                            }
                        }
                        $scope.getStoreList();
                        break;
                    }
                }
            }
        }
        //获取店铺信息
        $scope.getStoreList = function () {
            $http({ method: "POST", url: $rootScope._serverSvc + "getStoreList", data: { 'startNumber': 0, 'locationX': UserLocation.locationX, 'locationY': UserLocation.locationY, 'serviceType': $scope.input.serviceOption == 0 ? $scope.serviceType[$scope.currentServiceTypeIndex].id : 0, 'service': $scope.input.serviceOption, 'range': $scope.input.rangeOption, 'order': $scope.input.orderOption, 'keyword': '' } })
                .success(function (sdata) {
                    $scope.StoreList = JSON.parse(sdata.d);
                    if ($scope.StoreList.length > 0) {
                        $scope.lastStoreGeted = false;
                    }
                    else {
                        $scope.lastStoreGeted = true;
                    }
                })
        }
        //获取更多店铺信息
        $scope.getStoreListMore = function () {
            if (!$scope.lastStoreGeted && $scope.StoreList.length > 0) {
                $http({ method: "POST", url: $rootScope._serverSvc + "getStoreList", data: { 'startNumber': $scope.StoreList.length, 'locationX': UserLocation.locationX, 'locationY': UserLocation.locationY, 'serviceType': $scope.input.serviceOption == 0 ? $scope.serviceType[$scope.currentServiceTypeIndex].id : 0, 'service': $scope.input.serviceOption, 'range': $scope.input.rangeOption, 'order': $scope.input.orderOption, 'keyword': '' } })
                .success(function (sdata) {
                    var storeData = JSON.parse(sdata.d);
                    if (storeData.length > 0) {
                        $scope.lastStoreGeted = false;
                        var i;
                        for (i = 0; i <= storeData.length - 1; i++) {
                            $scope.StoreList.push(storeData[i]);
                        }
                    }
                    else {
                        $scope.lastStoreGeted = true;
                    }
                })
                .finally(function () {
                    $scope.$broadcast("scroll.infiniteScrollComplete");
                });
            }
        }
        //是否已经获得了最后一个店铺
        $scope.moreDataCanBeLoaded = function () {
            return !$scope.lastStoreGeted;
        }
        $scope.init();

    });